#include <QtGui>

#include "arrow.h"

Arrow::Arrow(void)
   {
   setFlag(QGraphicsItem::ItemIsSelectable, true);
   setAcceptedMouseButtons(Qt::LeftButton);
   }

void Arrow::drawArrow(int posX, int ini, int fim, int dir, QColor color, QString text, int srcPort, int dstPort, int numP)
   {
   myIni = ini;
   myEnd = fim;
   myPosX = posX;
   myDir = dir;
   myColor = color;
   myText = text;
   mySrcPort = srcPort;
   myDstPort = dstPort;
	numPacket = numP;
   update();
   }

QRectF Arrow::boundingRect() const
   {
   if (myDir)
      {
      return QRectF(myIni - 30, myPosX - 10, myEnd - myIni + 60, 20);
      }
   else
      {
      return QRectF(myEnd - 30, myPosX - 10, myIni - myEnd + 60, 20);
      }

   }

void Arrow::paint(QPainter *painter, const QStyleOptionGraphicsItem *option,
      QWidget *widget)
   {
   QString strAux;
   setZValue(1);

   painter->setRenderHint(QPainter::Antialiasing, true);
   painter->setPen(Qt::NoPen);
   painter->setBrush(QBrush(myColor, Qt::SolidPattern));

   if (myDir)
      {
      painter->drawRect(myIni, myPosX - 10, myEnd - myIni, 20);
      }
   else
      {
      painter->drawRect(myEnd, myPosX - 10, myIni - myEnd, 20);
      }

   painter->setPen(Qt::black);
   painter->setFont(QFont("Courier New", 8, QFont::Normal, false));
   QRectF rect = boundingRect();
   rect.adjust(0, -5, 0, -5);
   painter->drawText(rect, Qt::AlignCenter, myText);

   painter->setRenderHint(QPainter::Antialiasing, true);
   painter->setPen(QPen(Qt::black, 0, Qt::SolidLine, Qt::RoundCap));
   painter->setBrush(QBrush(Qt::black, Qt::SolidPattern));
   painter->drawLine(myIni, myPosX + 3, myEnd, myPosX + 3);

   if (myDir)
      {
      QPointF points[3] =
         {
         QPointF(myEnd - 8, myPosX - 1),
         QPointF(myEnd, myPosX + 3),
         QPointF(myEnd - 8, myPosX + 7)
         };
      painter->drawPolygon(points, 3);
      }
   else
      {
      QPointF points[3] =
         {
         QPointF(myEnd + 8, myPosX - 1),
         QPointF(myEnd, myPosX + 3),
         QPointF(myEnd + 8, myPosX + 7)
         };
      painter->drawPolygon(points, 3);
      }

   if (myDir)
      {
      strAux.setNum(mySrcPort, 10);
      painter->setFont(QFont("Courier New", 6, QFont::Bold, false));
      painter->drawText(myIni - 30, myPosX + 5, strAux);

      strAux.setNum(myDstPort, 10);
      painter->setFont(QFont("Courier New", 6, QFont::Bold, false));
      painter->drawText(myEnd + 6, myPosX + 5, strAux);
      }
   else
      {
      strAux.setNum(myDstPort, 10);
      painter->setFont(QFont("Courier New", 6, QFont::Bold, false));
      painter->drawText(myEnd - 30, myPosX + 5, strAux);

      strAux.setNum(mySrcPort, 10);
      painter->setFont(QFont("Courier New", 6, QFont::Bold, false));
      painter->drawText(myIni + 6, myPosX + 5, strAux);
      }
   }

void Arrow::mousePressEvent ( QGraphicsSceneMouseEvent * event )
   {
	emit (packetClicked(numPacket));
   event->setAccepted(false);
   }
