#ifndef ARROW_H
#define ARROW_H

#include <QGraphicsObject>

class QGraphicsPolygonItem;
class QGraphicsLineItem;
class QGraphicsScene;
class QRectF;
class QGraphicsSceneMouseEvent;
class QPainterPath;

class Arrow : public QGraphicsObject
   {
	Q_OBJECT
   public:
		Arrow(void);

		void drawArrow(int posX, int ini, int end, int dir, QColor color, QString text, int srcPort, int dstPort, int numP);

		QRectF boundingRect() const;

	signals:
		void packetClicked (int numPacket);

   private:
      int myIni, myEnd, myPosX, myDir, mySrcPort, myDstPort;
      QColor myColor;
      QString myText;
		int numPacket;

   protected:
      void paint(QPainter *painter, const QStyleOptionGraphicsItem *option, QWidget *widget = 0);
      void mousePressEvent ( QGraphicsSceneMouseEvent * event );
   };

#endif // ARROW_H
