#include <QtGui>
#include "bargraph.h"

barGraph::barGraph()
	{
	}

QRectF barGraph::boundingRect() const
	{
   return QRectF(BAR_XPOS_INI, myPos, myValEnd + 200, BAR_HEIGHT);
	}

void barGraph::drawBar(int pos, int val, int valT, QString sName, QColor color)
	{
	myVal = val;
	myPos = pos * (BAR_HEIGHT + BAR_SPACE);
   myName = sName;
	if (val != 0)
		{
		myValPerc = (((double)myVal/(double)valT)) * 100;
      myValEnd = (BAR_MAX_X*(double)myVal)/(double)valT;
		}
	else
		{
		myValPerc = 0;
      myValEnd = 0;
		}
	myColor = color;
	update();
	}

void barGraph::paint(QPainter *painter, const QStyleOptionGraphicsItem *option,
		QWidget *widget)
	{
	QString strAux;
	painter->setRenderHint(QPainter::Antialiasing, true);

	painter->setPen(Qt::black);
	painter->setFont(QFont("Courier New", 10, QFont::Bold, false));
	QRectF rect (0, myPos + 3, BAR_XPOS_INI - 15, BAR_HEIGHT);
	painter->drawText(rect, Qt::AlignRight, myName);

   QLinearGradient linearGrad(BAR_XPOS_INI, myPos, BAR_XPOS_INI + myValEnd, myPos + BAR_HEIGHT);
	linearGrad.setColorAt(0, Qt::black);
	linearGrad.setColorAt(1, myColor);

	painter->setPen(Qt::NoPen);
	painter->setBrush(linearGrad);
   painter->drawRect(BAR_XPOS_INI, myPos, myValEnd, BAR_HEIGHT);

	painter->setPen(Qt::black);
	painter->setFont(QFont("Courier New", 9, QFont::Normal, false));
   rect.setRect(BAR_XPOS_INI + myValEnd + 15, myPos + 3, 200, BAR_HEIGHT);
	strAux.sprintf("%3.2f% - %i", myValPerc, myVal);
	painter->drawText(rect, Qt::AlignLeft, strAux);
	}

