#ifndef DEFINES_H
#define DEFINES_H

#define ver_num_maj   0
#define ver_num_min   1

#define ver_day		27
#define ver_month		04
#define ver_year		2010

#define program_name   "VoIPFix"

//defines
#define LINE_LEN 16
#define ETHER_ADDR_LEN	6
#define SIZE_ETHERNET 14

#define PKT_SIP		1
#define PKT_SIP_SDP	2
#define PKT_RTP		3

//defines of transaction type
#define TRANS_TYPE_NONE			0
#define TRANS_TYPE_REGISTER	1
#define TRANS_TYPE_INVITE		2
#define TRANS_TYPE_ACK			3
#define TRANS_TYPE_CANCEL		4
#define TRANS_TYPE_BYE			5
#define TRANS_TYPE_OPTIONS		6
#define TRANS_TYPE_INFO			7
#define TRANS_TYPE_REFER		8
#define TRANS_TYPE_NOTIFY		9

//defines of transaction status code
#define TRANS_STATUS_NONE     0
#define TRANS_STATUS_UNKNOW   800
#define TRANS_STATUS_CANCEL   801
#define TRANS_STATUS_BYE      802

//RTP error level on report
#define ERROR_RTP_NOTHING		1
#define ERROR_RTP_LIGHT			2
#define ERROR_RTP_MIDDLE		3
#define ERROR_RTP_SERIOUS			4

//SIP error level on report
#define ERROR_SIP_NOTHING			1
#define ERROR_SIP_LIGHT			2
#define ERROR_SIP_MIDDLE			3
#define ERROR_SIP_SERIOUS			4

#define RTP_MAX_INTERVALO		100

//defines of SIP analysis state machine, for calls
#define EST_SIP_IDDLE					1		//stoped
#define EST_SIP_CALLING					2		//sent INVITE
#define EST_SIP_PROCEEDING				3		//sent/received 1xx message
#define EST_SIP_COMPLETED_2xx			4		//sent/received 2xx message
#define EST_SIP_COMPLETED_2XX_ACK	5		//sent/received ACK for 2xx message
#define EST_SIP_COMPLETED				6		//sent/received message from 300 to 699
#define EST_SIP_COMPLETED_ACK			7		//sent/received ACK for messge from 300 to 699
#define EST_SIP_TERMINATED				8		//sent/received BYE
#define EST_SIP_TERMINATED_OK			9		//sent/received 200 OK for BYE message
#define EST_SIP_RECEIVED				10		//received INVITE

#define EST_SIP_REGISTERING			11		//sent REGISTER without authentication
#define EST_SIP_RE_REGISTERING		12		//sent REGISTER again with authentication

#define EST_SIP_ERRO_DESL				13		//state it has detected error at shutdown.

//defines for codecs
#define SILENCIO_PCMU				0xFF
#define SILENCIO_PCMA				0x55

#define G711_PCMU						0x00
#define G711_PCMA						0x08
#endif // DEFINES_H
