#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QtGui>
#include <ui_mainwindow.h>
#include <voipfixmanager.h>
#include <windowtransactions.h>
#include <windowcapture.h>
#include <windowgraph.h>
#include <windowpackets.h>
#include <windowreport.h>
#include <windowplay.h>
#include <windowfilter.h>
#include <windowestatisticas.h>
#include <windowabout.h>

class MainWindow : public QMainWindow, public Ui::MainWindow
   {
   Q_OBJECT
   public:
      MainWindow();
      ~MainWindow();
		void closeEvent(QCloseEvent *event);

	public slots:
      void statusMessage(QString strMessage);
      void actOpenFile(void);
      void actOpenSequentialFiles(void);
      void actSaveFile(void);
      void actStartCapture(void);
      void actStopCapture (void);
      void actClose(void);
      void actAbout(void);
      void actManual(void);
      void actWebsite(void);

		void configureCapture(int device, char * filter);
      void configureCancel(bool closing);

      void closingTransactions(bool closing);
		void transSelected (QList<int> transSel);
      void transSelectedLastPacket (QList<int> transSel);
		void transSelectedReport(QList<int> transSel);
		void transSelectedPlay(int transSel);
		void transFilter(void);
      void transStatistics(void);

		void closingGraph (bool closing);
		void closingPackets (bool closing);
		void closingReport (bool closing);
		void closingPlay (bool closing);
		void closingFilter (bool closing);
      void closingStatistics (bool closing);
      void closingAbout (bool closing);

		void packetClicked (int numPacket);
      void analysisFinishedSignal(int numSIP, int numRTP);
      void parameterFilter (transFilter_t tFilter);

   private:
      QTime timeAnalysis;
		VoIPFixManager * voipManager;
		WindowTransactions *windowTrans;
      WindowCapture *windowCap;
		WindowGraph *winGraph;
		windowPackets *winPackets;
		WindowReport *winReport;
		WindowPlay *winPlay;
		WindowFilter *winFilter;
      WindowStatistics *winStatistics;
      windowAbout *winAbout;

		QString filePath;

		QMdiArea * mdiArea;
      QMdiSubWindow *subWindowCap;
      QMdiSubWindow *subWindowTrans;
		QMdiSubWindow *subWindowGraph;
		QMdiSubWindow *subWindowPackets;
		QMdiSubWindow *subWindowReport;
		QMdiSubWindow *subWindowPlay;
		QMdiSubWindow *subWindowFilter;
      QMdiSubWindow *subWindowStatistics;
      QMdiSubWindow *subWindowAbout;

      bool deviceOpened;
      bool fileOpened;
   };

#endif // MAINWINDOW_H
