#include "rendergraph.h"

RenderGraph::RenderGraph (QWidget *parent)
	  : QWidget(parent)
	{
	setBackgroundRole(QPalette::Base);
	setAutoFillBackground(true);
	}

void RenderGraph::drawGraph (QList <IPADDRESS_t> ipList)
	{	
	update();
	}

void RenderGraph::mousePressEvent(QMouseEvent *event)
	{
	QPointF point = event->pos();
	emit (mouseClickedPos(point.x(), point.y()));
	}

void RenderGraph::paintEvent(QPaintEvent * event)
	{
	QPainter painter(this);

	painter.setRenderHint(QPainter::Antialiasing, true);
	painter.setPen(QPen(Qt::green, 0, Qt::SolidLine, Qt::RoundCap));
	painter.drawLine(0, 200, 100, 200);

	painter.setRenderHint(QPainter::Antialiasing, true);
	painter.setPen(QPen(Qt::green, 0, Qt::SolidLine, Qt::RoundCap));
	painter.drawLine(95, 195, 100, 200);

	painter.setRenderHint(QPainter::Antialiasing, true);
	painter.setPen(QPen(Qt::green, 0, Qt::SolidLine, Qt::RoundCap));
	painter.drawLine(95, 205, 100, 200);

	painter.setRenderHint(QPainter::Antialiasing, false);
	painter.setPen(QPen(Qt::black, 1, Qt::SolidLine, Qt::RoundCap));
	painter.setBrush(Qt::NoBrush);
	painter.drawRect(QRect(0, 0, width() - 2, height() - 2));
	}
