#include <QtGui>
#include "texthour.h"

TextHour::TextHour()
   {
   setFlag(QGraphicsItem::ItemIsSelectable, false);
   }

QRectF TextHour::boundingRect() const
   {
   const int Padding = 8;
   QFontMetricsF metrics = QFont("Courier New", 8, QFont::Bold, false);
   QRectF rect = metrics.boundingRect(myHourText);
   rect.adjust(-Padding, -Padding, +Padding, +Padding);
   rect.moveCenter(QPointF(45, myY));
   return rect;
   }

void TextHour::drawHour(int y, QString hourText)
   {
   myY = y;
   myHourText = hourText;
   update();
   }

void TextHour::paint(QPainter *painter, const QStyleOptionGraphicsItem *option,
      QWidget *widget)
   {
   setZValue(2);

   painter->setPen(Qt::black);
   painter->setFont(QFont("Courier New", 8, QFont::Bold, false));
   QRectF rect = boundingRect();
   painter->drawText(rect, Qt::AlignCenter, myHourText);
   }
