#include <QtGui>
#include "textip.h"

TextIP::TextIP()
   {
   setFlag(QGraphicsItem::ItemIsSelectable, false);
   }

QRectF TextIP::boundingRect() const
   {
   const int Padding = 8;
   QFontMetricsF metrics = QFont("Courier New", 8, QFont::Bold, false);
   QRectF rect = metrics.boundingRect(myIPText);
   rect.adjust(-Padding, -Padding, +Padding, +Padding);
   rect.moveCenter(QPointF(myX, 15));
   return rect;
   }

void TextIP::drawIP(int x, QString ipText)
   {
   myX = x;
   myIPText = ipText;
   update();
   }

void TextIP::paint(QPainter *painter, const QStyleOptionGraphicsItem *option,
      QWidget *widget)
   {
   setZValue(2);

   painter->setPen(Qt::black);
   painter->setFont(QFont("Courier New", 8, QFont::Bold, false));
   QRectF rect = boundingRect();
   painter->drawText(rect, Qt::AlignCenter, myIPText);
   }
