#ifndef VOIPFIXCAP_H
#define VOIPFIXCAP_H

#include <QtGui>

#include <voipfixwinpcap.h>
#include <pcap.h>

class VoIPFixCap : public QObject
	{
	Q_OBJECT
	public:
		VoIPFixCap();
		~VoIPFixCap();
		int startCap();
		QStringList * getDeviceList();
		int openDevice (int deviceNumber, int inPromiscuousMode, char * filter);
		void closeDevice (void);
		int openFile (char * fileName, char * filter);
      int openFileSequential (QStringList fileNames, char * filter);
      void closeFile (void);
      int saveFile (char * fileName);
      int packetDumpFile (const struct pcap_pkthdr *header, const u_char *pkt_data);
      int closeDumpFile (void);

   public slots:
      void rxPacket(pcap_pkthdr *header, const u_char *pkt_data);
      void rxEOF(void);


	signals:
		void winCapPacket(pcap_pkthdr *header, const u_char *pkt_data);
      void winCapEOF(void);

	private:
      VoIPFixWinpCap *voipWinpCap;
	};

#endif // VOIPFIXCAP_H
