#include "voipfixtransactions.h"
#include <time.h>

#include <osip_utils.h>

QList<transaction_t> transactions;
QReadWriteLock lock;
QMutex mutexLock;

int transCapNew;
int transCapUpdate;
int numSIP;
int numRTP;

void packetAnalyser(packet_t packet);
int transAdd(char * call_id, int posPacket, char * strTipo);
int transFind (char * call_id, int posIni, int posEnd);
void transAddMedia (int pos, char * ipMedia, char * portMedia, int Which);
void transAddMediaPkt (int posPacket, infoUDP_t * infoUDP, infoRTP_t * infoRTP);
int transGetStatusCode(int pos);
int transAddPacket(int numTransaction, int posPacket);
int transSetTypeTrans (int numTransaction, int intType, char *strType, int numPacket);
int strToIntTypeTrans (char * strType);
int transGetTypeTrans (int numTransaction);
int transSetStatusCodeDif (int pos, int statusCode);
void intStatusCodeToStr(int intStatusCode, char *strStatusCode);

VoIPFixTransactions::VoIPFixTransactions()
	{
   connect (&futureWatcher, SIGNAL(finished()), this, SLOT(analysisFinished2()));
   }

VoIPFixTransactions::~VoIPFixTransactions()
	{

	}

int VoIPFixTransactions::startTransactions()
   {
   transCapNew = -1;
   transCapUpdate = -1;
   transactions.clear();
   numSIP = 0;
   numRTP = 0;
	return 0;
   }

int VoIPFixTransactions::rxPacketsList (QList<packet_t> listaPacotes)
	{
	QProgressDialog dialog;
	dialog.setLabelText(QString(tr("Analisando pacote(s) usando %1 thread(s)...")).arg(QThread::idealThreadCount()));
	dialog.setModal(true);

   connect(&futureWatcher, SIGNAL(finished()), &dialog, SLOT(reset()));
	connect(&dialog, SIGNAL(canceled()), &futureWatcher, SLOT(cancel()));
	connect(&futureWatcher, SIGNAL(progressRangeChanged(int, int)), &dialog, SLOT(setRange(int, int)));
	connect(&futureWatcher, SIGNAL(progressValueChanged(int)), &dialog, SLOT(setValue(int)));

	listaPacotesAux = listaPacotes;
   futureWatcher.setFuture(QtConcurrent::map(listaPacotesAux, packetAnalyser));

	dialog.exec();
	qApp->processEvents();

	return 0;
	}

void VoIPFixTransactions::analysisFinished2(void)
	{
   analysisFinished(listaPacotesAux);
	}

void VoIPFixTransactions::clearListTransactions(void)
   {
   int i;
   int listSize;
   //transaction_t transactionsAux;

   listSize = transactions.size();
   for (i = 0; i < listSize; i++)
      {
      if (transactions.operator[](i).call_id != NULL)
         {
         free (transactions.operator[](i).call_id);
         }
      if (transactions.operator[](i).lock != NULL)
			{
         delete transactions.operator[](i).lock;
			}
      transactions.operator[](i).posPackets.clear();
//		transactionsAux = transactions.at(i);
//		transactionsAux.posPackets.clear();
      }

   transactions.clear();
	transLista.clear();
   listaPacotesAux.clear();
   numSIP = 0;
   numRTP = 0;
   transCapNew = -1;
   transCapUpdate = -1;
   }

QList <infoPacketTrans_t> VoIPFixTransactions::setTransSelected (QList<packet_t> packetsList, QList<int> transSel)
	{
   int j, i, k;
	int key;
   int transSelSize;
   int numPacketAux;

	QList <int> packetsTrans;
   int packetsTransSize;

   QList <contSSRC_t> lstSSRC;
   contSSRC_t lstSSRCAux;   

   QList <infoPacketTrans_t> infoPacketTransMain;
   QList <infoPacketTrans_t> infoPacketTransSec;
	infoPacketTrans_t infoPacketAux;

   //insertion sort algorithm to sort transSel, because in the most of case, it will be sorted
   transSelSize = transSel.size();
   for (j = 1; j < transSelSize; j++)
		{
		key = transSel.at(j);
		i = j - 1;
		while ((i >= 0) &&(transSel.at(i) > key))
			{
			transSel.replace(i+1, transSel.at(i));
			i--;
			}
		transSel.replace(i+1, key);
		}

   infoPacketTransMain.clear();
   lstSSRC.clear();
   for (j = 0; j < transSelSize; j++)
		{
      lstSSRCAux.numTrans = transSel.at(j);
      lstSSRCAux.lstSSRC.clear();
      lstSSRC.append(lstSSRCAux);

      packetsTrans = getListTransPackets(transSel.at(j));
      packetsTransSize = packetsTrans.size();

      for (i = 0; i < packetsTransSize; i++)
			{
			infoPacketAux.numPacket = packetsTrans.at(i);
			infoPacketAux.numTrans = transSel.at(j);
         infoPacketTransMain.append(infoPacketAux);         
			}
		}

   //quick sort algorithm to sort the packet list, from selected transactions
   packetsTransSize = infoPacketTransMain.size();
   quickSortInfoPackets (&infoPacketTransMain, 0, packetsTransSize-1);

   infoPacketTransSec.clear();

   for (j = 0; j < packetsTransSize; j++)
		{
      infoPacketAux = infoPacketTransMain.at(j);
      numPacketAux = infoPacketAux.numPacket;

      if (packetsList.at(numPacketAux).sip_message != NULL)
         {	//packet with SIP message
         infoPacketAux.time.tv_sec = packetsList.at(numPacketAux).header->ts.tv_sec;
         infoPacketAux.time.tv_usec = packetsList.at(numPacketAux).header->ts.tv_usec;

         infoPacketAux.srcIP = packetsList.at(numPacketAux).infoUDP->ip_src;
         infoPacketAux.srcPort = packetsList.at(numPacketAux).infoUDP->udp_sport;
         infoPacketAux.dstIP = packetsList.at(numPacketAux).infoUDP->ip_dst;
         infoPacketAux.dstPort = packetsList.at(numPacketAux).infoUDP->udp_dport;

         if (packetsList.at(numPacketAux).sip_message->sip_method != NULL)
            {	//request message
            if (packetsList.at(numPacketAux).sdp_message != NULL)
					{
               infoPacketAux.info.sprintf("%s/SDP", packetsList.at(numPacketAux).sip_message->sip_method);
					}
				else
					{
               infoPacketAux.info.sprintf("%s", packetsList.at(numPacketAux).sip_message->sip_method);
					}
				}
			else
            {	//answer message
            if (packetsList.at(numPacketAux).sdp_message != NULL)
					{
               infoPacketAux.info.sprintf("%i %s/SDP", packetsList.at(numPacketAux).sip_message->status_code, packetsList.at(numPacketAux).sip_message->reason_phrase);
					}
				else
					{
               infoPacketAux.info.sprintf("%i %s", packetsList.at(numPacketAux).sip_message->status_code, packetsList.at(numPacketAux).sip_message->reason_phrase);
					}
				}
         infoPacketAux.info.truncate(27);
         infoPacketTransSec.append(infoPacketAux);
			}
      else if (packetsList.at(numPacketAux).infoRTP != NULL)
			{
         for (k = 0; k < transSelSize; k++)
            {
            if (lstSSRC.at(k).numTrans == infoPacketAux.numTrans)
               {
               if (!lstSSRC.at(k).lstSSRC.contains(packetsList.at(numPacketAux).infoRTP->ssrc))
                  {
                  infoPacketAux.time.tv_sec = packetsList.at(numPacketAux).header->ts.tv_sec;
                  infoPacketAux.time.tv_usec = packetsList.at(numPacketAux).header->ts.tv_usec;

                  infoPacketAux.srcIP = packetsList.at(numPacketAux).infoUDP->ip_src;
                  infoPacketAux.srcPort = packetsList.at(numPacketAux).infoUDP->udp_sport;
                  infoPacketAux.dstIP = packetsList.at(numPacketAux).infoUDP->ip_dst;
                  infoPacketAux.dstPort = packetsList.at(numPacketAux).infoUDP->udp_dport;

                  infoPacketAux.info.sprintf("RTP %s", get_payload_type_str(packetsList.at(numPacketAux).infoRTP->pt));
                  lstSSRCAux = lstSSRC.at(k);
                  lstSSRCAux.lstSSRC.append(packetsList.at(numPacketAux).infoRTP->ssrc);
                  lstSSRC.replace(k, lstSSRCAux);
                  infoPacketAux.info.truncate(27);
                  infoPacketTransSec.append(infoPacketAux);
                  }
               break;
               }
            }
			}
		}

   return (infoPacketTransSec);
	}

QList <infoPacketTrans_t> VoIPFixTransactions::setTransSelectedLastPacket (QList<packet_t> packetsList, QList<int> transSel)
   {
	int j, i;
	int key;
	int transSelSize;
   int numSIP;
   int numRTP;
	int numPacketAux;
	char *reqAux;
   QString strAux;

	QList <int> packetsTrans;
	int packetsTransSize;

	QList <infoPacketTrans_t> infoPacketTransMain;
	infoPacketTrans_t infoPacketAux;

	//use insertion sort to sort transSel, because in most cases the list already come ordered
	transSelSize = transSel.size();
	for (j = 1; j < transSelSize; j++)
		{
		key = transSel.at(j);
		i = j - 1;
		while ((i >= 0) &&(transSel.at(i) > key))
			{
			transSel.replace(i+1, transSel.at(i));
			i--;
			}
		transSel.replace(i+1, key);
		}

	infoPacketTransMain.clear();
	for (j = 0; j < transSelSize; j++)
		{
      packetsTrans = getListTransPackets(transSel.at(j));

		packetsTransSize = packetsTrans.size();
		for (i = 0; i < packetsTransSize; i++)
			{
			infoPacketAux.numPacket = packetsTrans.at(i);
			infoPacketAux.numTrans = transSel.at(j);
			infoPacketTransMain.append(infoPacketAux);
			}
		}

	//use quicksort to sort list of packages fruit of selected transactions

	packetsTransSize = infoPacketTransMain.size();
	quickSortInfoPackets (&infoPacketTransMain, 0, packetsTransSize-1);

   numSIP = 0;
   numRTP = 0;
	for (j = 0; j < packetsTransSize; j++)
		{
		infoPacketAux = infoPacketTransMain.at(j);
		numPacketAux = infoPacketAux.numPacket;

		if (packetsList.at(numPacketAux).sip_message != NULL)
			{	//packet with SIP message
         numSIP++;
			infoPacketAux.time.tv_sec = packetsList.at(numPacketAux).header->ts.tv_sec;
			infoPacketAux.time.tv_usec = packetsList.at(numPacketAux).header->ts.tv_usec;

			infoPacketAux.srcIP = packetsList.at(numPacketAux).infoUDP->ip_src;
			infoPacketAux.srcPort = packetsList.at(numPacketAux).infoUDP->udp_sport;
			infoPacketAux.dstIP = packetsList.at(numPacketAux).infoUDP->ip_dst;
			infoPacketAux.dstPort = packetsList.at(numPacketAux).infoUDP->udp_dport;

			if (packetsList.at(numPacketAux).sip_message->sip_method != NULL)
				{	//request message
				if (packetsList.at(numPacketAux).sdp_message != NULL)
					{	//with SDP
					infoPacketAux.info.insert(0, "SIP/SDP");
					osip_uri_to_str(packetsList.at(numPacketAux).sip_message->req_uri, &reqAux);
					infoPacketAux.coment.sprintf("Request: %s %s, with SDP", packetsList.at(numPacketAux).sip_message->sip_method, reqAux);
					osip_free(reqAux);
					}
				else
					{	//sem SDP
					infoPacketAux.info.insert(0, "SIP");
					osip_uri_to_str(packetsList.at(numPacketAux).sip_message->req_uri, &reqAux);
					infoPacketAux.coment.sprintf("Request: %s %s", packetsList.at(numPacketAux).sip_message->sip_method, reqAux);
					osip_free(reqAux);
					}
				}
			else
				{	//answer message
				if (packetsList.at(numPacketAux).sdp_message != NULL)
					{	//com SDP
					infoPacketAux.info.insert(0, "SIP/SDP");
					infoPacketAux.coment.sprintf("Status: %i %s , with SDP", packetsList.at(numPacketAux).sip_message->status_code, packetsList.at(numPacketAux).sip_message->reason_phrase);
					}
				else
					{	//sem SDP
					infoPacketAux.info.insert(0, "SIP");
					infoPacketAux.coment.sprintf("Status: %i %s", packetsList.at(numPacketAux).sip_message->status_code, packetsList.at(numPacketAux).sip_message->reason_phrase);
					}
				}
			infoPacketTransMain.replace(j, infoPacketAux);
			}
		else if (packetsList.at(numPacketAux).infoRTP != NULL)
			{
         numRTP++;
			infoPacketAux.time.tv_sec = packetsList.at(numPacketAux).header->ts.tv_sec;
			infoPacketAux.time.tv_usec = packetsList.at(numPacketAux).header->ts.tv_usec;

			infoPacketAux.srcIP = packetsList.at(numPacketAux).infoUDP->ip_src;
			infoPacketAux.srcPort = packetsList.at(numPacketAux).infoUDP->udp_sport;
			infoPacketAux.dstIP = packetsList.at(numPacketAux).infoUDP->ip_dst;
			infoPacketAux.dstPort = packetsList.at(numPacketAux).infoUDP->udp_dport;

			infoPacketAux.info.sprintf("RTP");
			infoPacketAux.coment.sprintf("PT=%s - SSRC=0x%x - Seq=%i - Time=%i", get_payload_type_str(packetsList.at(numPacketAux).infoRTP->pt), packetsList.at(numPacketAux).infoRTP->ssrc, packetsList.at(numPacketAux).infoRTP->seq, packetsList.at(numPacketAux).infoRTP->ts);
			infoPacketTransMain.replace(j, infoPacketAux);
			}
		}

	strAux = QString(tr("Pacotes SIP=[%1] - Pacotes RTP=[%2]").arg(numSIP).arg(numRTP));
   emit (statusMessage(strAux));
	return (infoPacketTransMain);
   }

QList <infoReportTrans_t> VoIPFixTransactions::setTransSelectedReport (QList<packet_t> packetsList, QList<int> transSel)
	{
	int j, i, k, l, m;
	int key;
	int tamTransSel;
	QList <int> packetsTrans;
	int packetsTransSize;
	QList <infoReportTrans_t> infoPacketTransMain;
	infoReportTrans_t infoPacketTransAux;
	infoRTP_t * infoRTPAux;
	sourceRTP_t originatorRTP;
	sourceRTP_t receiverRTP;
	unsigned int extended_max, expectedOrg, expectedRec, lostOrg, lostRec;
	bool firstOriginator, firstReceiver;
	int firstRTPOrig, firstRTPRecpt;
	char tStart[30];
	char tStop[30];
	char IPFrom[24];
	char * userFrom = NULL;
	char IPTo[24];
	char * userTo = NULL;
	char state[50];
	transState_t originatorState;
	transState_t receiverState;
	osip_header_t *header;
	int statusCode;
	IPADDRESS_t ip_src;
	IPADDRESS_t ip_dst;
	int reqType;
	int CSeq;
	sdp_media_t * sdpMediaAux;
	char *strAux;
	QString qStrAux;

	time_t *local_tv_sec;
	struct tm *ltime;
	char timestr[16];

	transaction_t transactionsAux;
	packet_t packetFirst;
	packet_t packetLast;
	int typeTrans;
	double duration;
	double percLost;
	int durationHour, durationMin, durationSec;


	//using insertion sort to sort transSel, because in most cases the list already come ordered
	tamTransSel = transSel.size();
	for (j = 1; j < tamTransSel; j++)
		{
		key = transSel.at(j);
		i = j - 1;
		while ((i >= 0) &&(transSel.at(i) > key))
			{
			transSel.replace(i+1, transSel.at(i));
			i--;
			}
		transSel.replace(i+1, key);
		}

	infoPacketTransMain.clear();

	for (j = 0; j < tamTransSel; j++)
		{
		typeTrans = transGetTypeTrans(transSel.at(j));

      clearInfoPacket(&infoPacketTransAux);
		if ((typeTrans == TRANS_TYPE_INVITE) || (typeTrans == TRANS_TYPE_REGISTER))
			{
         packetsTrans = getListTransPackets(transSel.at(j));
			packetsTransSize = packetsTrans.size();

			//using quick sort to sort list of packages
			quickSortPackets(&packetsTrans, 0, packetsTransSize-1);

			transactionsAux = transactions.at(transSel.at(j));

			packetFirst = packetsList.at(transactionsAux.posPackets.at(0));
			if (packetFirst.sip_message != NULL)
				{
				userFrom = packetFirst.sip_message->from->url->username;
				userTo = packetFirst.sip_message->to->url->username;

				sprintf(IPFrom, "%i.%i.%i.%i",   packetFirst.infoUDP->ip_src.ip[0], packetFirst.infoUDP->ip_src.ip[1],
															packetFirst.infoUDP->ip_src.ip[2], packetFirst.infoUDP->ip_src.ip[3]);

				sprintf(IPTo, "%i.%i.%i.%i",     packetFirst.infoUDP->ip_dst.ip[0], packetFirst.infoUDP->ip_dst.ip[1],
															packetFirst.infoUDP->ip_dst.ip[2], packetFirst.infoUDP->ip_dst.ip[3]);

				local_tv_sec = &packetFirst.header->ts.tv_sec;
				ltime = localtime (local_tv_sec);
				strftime( timestr, sizeof timestr, "%H:%M:%S", ltime);
				sprintf(tStart, "%s.%.6ld", timestr, packetFirst.header->ts.tv_usec);

				packetLast = packetsList.at(transactionsAux.posPackets.at(transactionsAux.posPackets.size()-1));
				local_tv_sec = &packetLast.header->ts.tv_sec;
				ltime = localtime (local_tv_sec);
				strftime( timestr, sizeof timestr, "%H:%M:%S", ltime);
				sprintf(tStop, "%s.%.6ld", timestr, packetLast.header->ts.tv_usec);

            intStatusCodeToStr(transactionsAux.statusCode, &state[0]);

				if (typeTrans == TRANS_TYPE_INVITE)
					{	//only INVITE transactions
					//analysis of SIP troubles/events in calls transactions
					clearTransState(&originatorState);
					clearTransState(&receiverState);

					for (k = 0; k < packetsTransSize; k++)
						{
						if (packetsList.at(packetsTrans.at(k)).sip_message != NULL)
							{
							//note important information for analysis
							statusCode = packetsList.at(packetsTrans.at(k)).sip_message->status_code;
							ip_src.ipdw = packetsList.at(packetsTrans.at(k)).infoUDP->ip_src.ipdw;
							ip_dst.ipdw = packetsList.at(packetsTrans.at(k)).infoUDP->ip_dst.ipdw;
							reqType = strToIntTypeTrans (packetsList.at(packetsTrans.at(k)).sip_message->sip_method);
							CSeq = atoi(packetsList.at(packetsTrans.at(k)).sip_message->cseq->number);

							switch (originatorState.state)
								{	//analyzing	state machine of call originator
								case EST_SIP_IDDLE:
									{	//no defined state yet
									if (reqType == TRANS_TYPE_INVITE)
										{	//first really INVITE message
										//define IP of originator and initial state
										originatorState.ip.ipdw = ip_src.ipdw;
										originatorState.state = EST_SIP_CALLING;
										receiverState.ip.ipdw = ip_dst.ipdw;
										originatorState.CSeq = CSeq;
										l = 0;
										do
											{
											if ((sdpMediaAux = (sdp_media_t*)osip_list_get(&packetsList.at(packetsTrans.at(k)).sdp_message->m_medias, l)) == NULL)
												break;

											if (strcmp (sdpMediaAux->m_media, "audio") == 0)
												{
												m = 0;
												do
													{
													if ((strAux = (char*)osip_list_get(&sdpMediaAux->m_payloads, m)) == NULL)
														break;
													originatorState.codecs.append(atoi(strAux));
													m++;
													}while (strAux != NULL);
												break;
												}
											l++;
											}while (sdpMediaAux != NULL);
										}
									break;
									}
								case EST_SIP_CALLING:
									{
									if (ip_dst.ipdw == originatorState.ip.ipdw)
										{	//message to the originator
										if ((statusCode > 0) && (statusCode < 200))
											{	//provisional message yet
											originatorState.state = EST_SIP_PROCEEDING;
											originatorState.status = statusCode;
											}
										else if ((statusCode == 200) || (statusCode == 202))
											{
											originatorState.state = EST_SIP_COMPLETED_2xx;
											originatorState.status = statusCode;
											}
										else if (statusCode >= 300)
											{
											if (statusCode == 415)
												{
												infoPacketTransAux.erroSIP = ERROR_SIP_MIDDLE;
                                    qStrAux = QString ("\r\n");
                                    qStrAux.append(tr(" - Receptor no aceitou codificadores de udio do originador ( "));
												for (l = 0; l < originatorState.codecs.size(); l++)
													{
													qStrAux.append(get_payload_type_str(originatorState.codecs.at(l)));
													qStrAux.append(" ");
													}
                                    qStrAux.append(").\r\n");
                                    qStrAux.append(tr(" - Chamada no foi completada."));
												infoPacketTransAux.erroSIPText.append(qStrAux);
												}
											}
										else if (reqType != TRANS_TYPE_NONE)
											{

											}
										}
									else if (ip_dst.ipdw == receiverState.ip.ipdw)
										{	//message to the receiver

										}
									break;
									}
								case EST_SIP_PROCEEDING:
									{
									if (ip_dst.ipdw == originatorState.ip.ipdw)
										{	//message to the originator
										if ((statusCode > 0) && (statusCode < 200))
											{	//provisional message yet
											originatorState.status = statusCode;
											}
										else if ((statusCode == 200) || (statusCode == 202))
											{
											originatorState.state = EST_SIP_COMPLETED_2xx;
											originatorState.status = statusCode;
											}
										else if (statusCode >= 300)
											{
											if (statusCode == 415)
												{
												infoPacketTransAux.erroSIP = ERROR_SIP_MIDDLE;
                                    qStrAux = QString ("\r\n");
                                    qStrAux.append(tr(" - Receptor no aceitou codificadores de udio do originador ( "));
												for (l = 0; l < originatorState.codecs.size(); l++)
													{
													qStrAux.append(get_payload_type_str(originatorState.codecs.at(l)));
													qStrAux.append(" ");
													}
                                    qStrAux.append(").\r\n");
                                    qStrAux.append(tr(" - Chamada no foi completada."));
												infoPacketTransAux.erroSIPText.append(qStrAux);
												}
											}
										else if (reqType != TRANS_TYPE_NONE)
											{

											}
										}
									else if (ip_dst.ipdw == receiverState.ip.ipdw)
										{	//message to the receiver

										}
									break;
									}
								case EST_SIP_COMPLETED_2xx:
									{
									if (ip_dst.ipdw == originatorState.ip.ipdw)
										{	//message to the originator
										if ((statusCode > 0) && (statusCode < 200))
											{	//provisional message yet
											}
										else if ((statusCode == 200) || (statusCode == 202))
											{
											}
										else if (statusCode >= 300)
											{

											}
										else if (reqType != TRANS_TYPE_NONE)
											{

											}
										}
									else if (ip_dst.ipdw == receiverState.ip.ipdw)
										{	//message to the receiver
										if (reqType == TRANS_TYPE_ACK)
											{
											originatorState.state = EST_SIP_COMPLETED_2XX_ACK;
											}
										}
									break;
									}
								case EST_SIP_COMPLETED_2XX_ACK:
									{
									if (ip_dst.ipdw == originatorState.ip.ipdw)
										{	//message to the originator
										if ((statusCode > 0) && (statusCode < 200))
											{	//provisional message yet
											}
										else if ((statusCode == 200) || (statusCode == 202))
											{
											}
										else if (statusCode >= 300)
											{

											}
										else if (reqType != TRANS_TYPE_NONE)
											{
											if (reqType == TRANS_TYPE_BYE)
												{
												originatorState.state = EST_SIP_TERMINATED;
												}
											}
										}
									else if (ip_dst.ipdw == receiverState.ip.ipdw)
										{	//message to the receiver
										if (reqType == TRANS_TYPE_BYE)
											{
											originatorState.state = EST_SIP_TERMINATED;
											}
										}
									break;
									}
								case EST_SIP_COMPLETED:
									{
									if (ip_dst.ipdw == originatorState.ip.ipdw)
										{	//message to the originator
										if ((statusCode > 0) && (statusCode < 200))
											{	//provisional message yet
											}
										else if ((statusCode == 200) || (statusCode == 202))
											{
											}
										else if (statusCode >= 300)
											{

											}
										else if (reqType != TRANS_TYPE_NONE)
											{

											}
										}
									else if (ip_dst.ipdw == receiverState.ip.ipdw)
										{	//message to the receiver

										}
									break;
									}
								case EST_SIP_COMPLETED_ACK:
									{
									if (ip_dst.ipdw == originatorState.ip.ipdw)
										{	//message to the originator
										if ((statusCode > 0) && (statusCode < 200))
											{	//provisional message yet
											}
										else if ((statusCode == 200) || (statusCode == 202))
											{
											}
										else if (statusCode >= 300)
											{

											}
										else if (reqType != TRANS_TYPE_NONE)
											{

											}
										}
									else if (ip_dst.ipdw == receiverState.ip.ipdw)
										{	//message to the receiver

										}
									break;
									}
								case EST_SIP_TERMINATED:
									{
									if (ip_dst.ipdw == originatorState.ip.ipdw)
										{	//message to the originator
										if ((statusCode > 0) && (statusCode < 200))
											{	//provisional message yet
											}
										else if ((statusCode == 200) || (statusCode == 202))
											{
											originatorState.state = EST_SIP_TERMINATED_OK;
											}
										else if (statusCode >= 300)
											{
											if ((statusCode == 481) || (statusCode == 500))
												{
												originatorState.state = EST_SIP_ERRO_DESL;
												infoPacketTransAux.erroSIP = ERROR_SIP_SERIOUS;
												if (CSeq > originatorState.CSeq)
													{
                                       infoPacketTransAux.erroSIPText.append("\r\n");
                                       infoPacketTransAux.erroSIPText.append(tr(" - Receptor no aceitou mensagem de BYE (desligamento) do originador."));
                                       infoPacketTransAux.erroSIPText.append("\r\n");
                                       infoPacketTransAux.erroSIPText.append(tr(" - Chamada no foi finalizada corretamente!"));
													}
												else
													{
                                       qStrAux = QString("\r\n");
                                       qStrAux.append(tr(" - Receptor no aceitou mensagem de BYE (desligamento) do originador."));
                                       qStrAux.append(tr(" - O valor do campo CSeq est incorreto."));
                                       qStrAux.append("\r\n");
                                       qStrAux.append(tr(" - Chamada no foi finalizada corretamente!"));
													infoPacketTransAux.erroSIPText.append(qStrAux);
                                       qStrAux = QString("\r\n");
													qStrAux.append(tr(" - Valor do CSeq da requisio inicial = %1.").arg(originatorState.CSeq).arg(CSeq));
                                       qStrAux.append("\r\n");
													qStrAux.append(tr(" - Valor do CSeq da mensagem de BYE = %1").arg(CSeq));
													infoPacketTransAux.erroSIPText.append(qStrAux);
													}
												}
											}
										else if (reqType != TRANS_TYPE_NONE)
											{

											}
										}
									else if (ip_dst.ipdw == receiverState.ip.ipdw)
										{	//message to the receiver
										if ((statusCode > 0) && (statusCode < 200))
											{	//provisional message yet
											}
										else if ((statusCode == 200) || (statusCode == 202))
											{
											originatorState.state = EST_SIP_TERMINATED_OK;
											}
										else if (statusCode >= 300)
											{
											if ((statusCode == 481) || (statusCode == 500))
												{
												originatorState.state = EST_SIP_ERRO_DESL;
												infoPacketTransAux.erroSIP = ERROR_SIP_SERIOUS;
												if (CSeq > originatorState.CSeq)
													{
                                       infoPacketTransAux.erroSIPText.append("\r\n");
                                       infoPacketTransAux.erroSIPText.append(tr(" - Originador no aceitou mensagem de BYE (desligamento) do receptor. Chamada no foi finalizada corretamente!"));
													}
												else
													{
                                       qStrAux = QString("\r\n");
                                       qStrAux.append(tr(" - Originador no aceitou mensagem de BYE (desligamento) do receptor, pois valor do campo CSeq est incorreto. Chamada no foi finalizada corretamente!"));
													infoPacketTransAux.erroSIPText.append(qStrAux);
                                       qStrAux = QString("\r\n");
													qStrAux.append(tr(" - Valor do CSeq da requisio inicial = %1.").arg(originatorState.CSeq));
                                       qStrAux.append("\r\n");
													qStrAux.append(tr(" - Valor do CSeq da mensagem de BYE = %1").arg(CSeq));
													infoPacketTransAux.erroSIPText.append(qStrAux);
													}
												}
											}
										else if (reqType != TRANS_TYPE_NONE)
											{

											}
										}
									break;
									}
								case EST_SIP_TERMINATED_OK:
									{
									if (ip_dst.ipdw == originatorState.ip.ipdw)
										{	//message to the originator
										if ((statusCode > 0) && (statusCode < 200))
											{	//provisional message yet
											}
										else if ((statusCode == 200) || (statusCode == 202))
											{
											}
										else if (statusCode >= 300)
											{

											}
										else if (reqType != TRANS_TYPE_NONE)
											{

											}
										}
									else if (ip_dst.ipdw == receiverState.ip.ipdw)
										{	//message to the receiver

										}
									break;
									}
								case EST_SIP_RECEIVED:
									{
									if (ip_dst.ipdw == originatorState.ip.ipdw)
										{	//message to the originator
										if ((statusCode > 0) && (statusCode < 200))
											{	//provisional message yet
											}
										else if ((statusCode == 200) || (statusCode == 202))
											{
											}
										else if (statusCode >= 300)
											{

											}
										else if (reqType != TRANS_TYPE_NONE)
											{

											}
										}
									else if (ip_dst.ipdw == receiverState.ip.ipdw)
										{	//message to the receiver

										}
									break;
									}
								}
							}
						}

					//------Packet lost calculation-------
					originatorRTP.absence = false;
					for (k = 0; k < packetsTransSize; k++)
						{
						if (packetsList.at(packetsTrans.at(k)).infoRTP != NULL)
							{
							infoRTPAux = packetsList.at(packetsTrans.at(k)).infoRTP;
							if (infoRTPAux->ssrc == transactions.at(transSel.at(j)).ssrcSrc)
								{
								initSeqSourceRTP(&originatorRTP, infoRTPAux->seq, infoRTPAux->ts, packetsList.at(packetsTrans.at(k)).header->ts);
								originatorRTP.max_seq = infoRTPAux->seq - 1;
								originatorRTP.probation = MIN_SEQUENTIAL;
								firstRTPOrig = k;
								break;
								}
							}
						}

					receiverRTP.absence = false;
					for (k = 0; k < packetsTransSize; k++)
						{
						if (packetsList.at(packetsTrans.at(k)).infoRTP != NULL)
							{
							infoRTPAux = packetsList.at(packetsTrans.at(k)).infoRTP;
							if (infoRTPAux->ssrc == transactions.at(transSel.at(j)).ssrcDst)
								{
								initSeqSourceRTP(&receiverRTP, infoRTPAux->seq, infoRTPAux->ts, packetsList.at(packetsTrans.at(k)).header->ts);
								receiverRTP.max_seq = infoRTPAux->seq - 1;
								receiverRTP.probation = MIN_SEQUENTIAL;
								firstRTPRecpt = k;
								break;
								}
							}
						}

					firstOriginator = false;
					firstReceiver = false;

					//look at for all transaction packets, accounting RTP reports
					for (k = 0; k < packetsTransSize; k++)
						{
						if (packetsList.at(packetsTrans.at(k)).infoRTP != NULL)
							{
							infoRTPAux = packetsList.at(packetsTrans.at(k)).infoRTP;
							if (infoRTPAux->ssrc == transactions.at(transSel.at(j)).ssrcSrc)
								{
								if (firstOriginator == false)
									{
									infoPacketTransAux.Codec.sprintf("%s", get_payload_type_str(packetsList.at(packetsTrans.at(k)).infoRTP->pt));
									firstOriginator = true;
									}
								else
									{
									updateSeqRTP(&originatorRTP, infoRTPAux->seq, packetsList.at(packetsTrans.at(k)).header->ts, infoRTPAux->ts);
									}
								}
							else if (infoRTPAux->ssrc == transactions.at(transSel.at(j)).ssrcDst)
								{
								if (firstReceiver == false)
									{
									firstReceiver = true;
									}
								else
									{
									updateSeqRTP(&receiverRTP, infoRTPAux->seq, packetsList.at(packetsTrans.at(k)).header->ts, infoRTPAux->ts);
									}
								}
							}
						}

					if (firstOriginator)
						{
						extended_max = originatorRTP.cycles + originatorRTP.max_seq;
						expectedOrg = extended_max - originatorRTP.base_seq + 1;
						lostOrg = expectedOrg - originatorRTP.received;
						}

					if (firstReceiver)
						{
						extended_max = receiverRTP.cycles + receiverRTP.max_seq;
						expectedRec = extended_max - receiverRTP.base_seq + 1;
						lostRec = expectedRec - receiverRTP.received;
						}
					//------Packet lost calculation-------

					//------Jitter calculation-------
					if (firstOriginator)
						{
						infoRTPAux = packetsList.at(packetsTrans.at(firstRTPOrig)).infoRTP;
						initSeqSourceRTP(&originatorRTP, infoRTPAux->seq, infoRTPAux->ts, packetsList.at(packetsTrans.at(firstRTPOrig)).header->ts);
						originatorRTP.max_seq = infoRTPAux->seq - 1;
						originatorRTP.probation = MIN_SEQUENTIAL;
						}

					if (firstReceiver)
						{
						infoRTPAux = packetsList.at(packetsTrans.at(firstRTPRecpt)).infoRTP;
						initSeqSourceRTP(&receiverRTP, infoRTPAux->seq, infoRTPAux->ts, packetsList.at(packetsTrans.at(firstRTPRecpt)).header->ts);
						receiverRTP.max_seq = infoRTPAux->seq - 1;
						receiverRTP.probation = MIN_SEQUENTIAL;
						}

					firstOriginator = false;
					firstReceiver = false;

					//look at for all transaction packets, accounting RTP reports
					for (k = 0; k < packetsTransSize; k++)
						{
						if (packetsList.at(packetsTrans.at(k)).infoRTP != NULL)
							{
							infoRTPAux = packetsList.at(packetsTrans.at(k)).infoRTP;
							if (infoRTPAux->ssrc == transactions.at(transSel.at(j)).ssrcSrc)
								{
								if (firstOriginator == false)
									{
									firstOriginator = true;
									}
								else
									{
									jitterCalcPackets(&originatorRTP, infoRTPAux->seq, packetsList.at(packetsTrans.at(k)).header->ts, infoRTPAux->ts);
									}
								}
							else if (infoRTPAux->ssrc == transactions.at(transSel.at(j)).ssrcDst)
								{
								if (firstReceiver == false)
									{
									firstReceiver = true;
									}
								else
									{
									jitterCalcPackets(&receiverRTP, infoRTPAux->seq, packetsList.at(packetsTrans.at(k)).header->ts, infoRTPAux->ts);
									}
								}
							}
						}

					if (firstOriginator)
						{
						originatorRTP.meanJitter = (double)(originatorRTP.meanJitter / originatorRTP.received);
						}

					if (firstReceiver)
						{
						receiverRTP.meanJitter = (double)(receiverRTP.meanJitter / receiverRTP.received);
						}
					//------Jitter calculation-------

					duration = difftime(packetLast.header->ts.tv_sec, packetFirst.header->ts.tv_sec);
					durationHour = (int)duration/3600;
					durationSec = (int)duration%3600;
					durationMin = (int)durationSec/60;
					durationSec = (int)durationSec%60;

					infoPacketTransAux.Tipo.sprintf("%s", "INVITE");
					infoPacketTransAux.duration.sprintf("%2.2i:%2.2i:%2.2i", durationHour, durationMin, durationSec);

					if (firstOriginator)
						{
						infoPacketTransAux.maxJitterOrg.sprintf("%f", originatorRTP.maxJitter);
						infoPacketTransAux.meanJitterOrg.sprintf("%f", originatorRTP.meanJitter);
						percLost = (double)((double)lostOrg/(double)expectedOrg);
						infoPacketTransAux.packetLostPercOrg.sprintf("%f", percLost*100);
						infoPacketTransAux.sequenceErrorOrg.sprintf("%d", originatorRTP.sequenceError);
						}

					if (firstReceiver)
						{
						infoPacketTransAux.maxJitterRec.sprintf("%f", receiverRTP.maxJitter);
						infoPacketTransAux.meanJitterRec.sprintf("%f", receiverRTP.meanJitter);
						percLost = (double)((double)lostRec/(double)expectedRec);
						infoPacketTransAux.packetLostPercRec.sprintf("%f", percLost*100);
						infoPacketTransAux.sequenceErrorRec.sprintf("%d", receiverRTP.sequenceError);
						}

					if (transactions.at(transSel.at(j)).mediaSrcOK && transactions.at(transSel.at(j)).mediaDstOK)
						{
						if ((firstOriginator == false) && (firstReceiver == true))
							{
							infoPacketTransAux.erroRTP = ERROR_RTP_SERIOUS;
                     infoPacketTransAux.erroRTPText.append("\r\n");
                     infoPacketTransAux.erroRTPText.append(tr(" - No foi detectado fluxo RTP do originador da chamada."));
							}
						else if (originatorRTP.absence == true)
							{
							infoPacketTransAux.erroRTP = ERROR_RTP_MIDDLE;
                     infoPacketTransAux.erroRTPText.append("\r\n");
                     infoPacketTransAux.erroRTPText.append(tr(" - Detectado momentos de ausncia de udio no fluxo RTP do originador da chamada."));
							}
						if ((firstReceiver == false) && (firstOriginator == true))
							{
							infoPacketTransAux.erroRTP = ERROR_RTP_SERIOUS;
                     infoPacketTransAux.erroRTPText.append("\r\n");
                     infoPacketTransAux.erroRTPText.append(tr(" - No foi detectado fluxo RTP do receptor da chamada."));
							}
						else if (receiverRTP.absence == true)
							{
							infoPacketTransAux.erroRTP = ERROR_RTP_MIDDLE;
                     infoPacketTransAux.erroRTPText.append("\r\n");
                     infoPacketTransAux.erroRTPText.append(tr(" - Detectado momentos de ausncia de udio no fluxo RTP do receptor da chamada."));
							}
						if ((firstReceiver == false) && (firstOriginator == false))
							{
							infoPacketTransAux.erroRTP = ERROR_RTP_LIGHT;
                     infoPacketTransAux.erroRTPText.append("\r\n");
                     infoPacketTransAux.erroRTPText.append(tr(" - No foi capturado fluxo RTP da chamada."));
							}
						}
					}
				else if (typeTrans == TRANS_TYPE_REGISTER)
					{
					//analysis of SIP troubles/events in register transactions
					clearTransState(&originatorState);
					clearTransState(&receiverState);

					for (k = 0; k < packetsTransSize; k++)
						{
						if (packetsList.at(packetsTrans.at(k)).sip_message != NULL)
							{
							//note important information for analysis
							statusCode = packetsList.at(packetsTrans.at(k)).sip_message->status_code;
							ip_src.ipdw = packetsList.at(packetsTrans.at(k)).infoUDP->ip_src.ipdw;
							ip_dst.ipdw = packetsList.at(packetsTrans.at(k)).infoUDP->ip_dst.ipdw;
							reqType = strToIntTypeTrans (packetsList.at(packetsTrans.at(k)).sip_message->sip_method);

							switch (originatorState.state)
								{
								case EST_SIP_IDDLE:
									{
									if (reqType == TRANS_TYPE_REGISTER)
										{
										originatorState.ip.ipdw = ip_src.ipdw;
										originatorState.state = EST_SIP_REGISTERING;
										receiverState.ip.ipdw = ip_dst.ipdw;
										osip_message_header_get_byname(packetsList.at(packetsTrans.at(k)).sip_message,(const char *)"expires",1,&header);
										if (header != NULL)
											{
											originatorState.registerTime = atoi(header->hvalue);
											}
										}
									break;
									}
								case EST_SIP_REGISTERING:
									{
									if (ip_dst.ipdw == originatorState.ip.ipdw)
										{
										if (statusCode > 0)
											{
											switch (statusCode)
												{
												case 200:
													{
													break;
													}
												case 401:
												case 407:
													{
													break;
													}
												case 423:
													{
													infoPacketTransAux.erroSIP = ERROR_SIP_LIGHT;
													osip_message_header_get_byname(packetsList.at(packetsTrans.at(k)).sip_message,(const char *)"Min-expires",0,&header);
                                       infoPacketTransAux.erroRTPText.append("\r\n");
                                       infoPacketTransAux.erroRTPText.append(tr(" - Servidor de registro negou pedido, pois usurio fez solicitao com tempo muito curto."));
													if (header != NULL)
														{
                                          qStrAux = QString("\r\n");
                                          qStrAux.append(tr(" - Tempo de registro da solicitao foi de %1 segundos. Servidor pede no mnimo %2 segundos.").arg(originatorState.registerTime).arg(header->hvalue));
														infoPacketTransAux.erroRTPText.append(qStrAux);
														}
													break;
													}
												}
											}
										else
											{

											}
										}
									break;
									}
								case EST_SIP_RE_REGISTERING:
									{
									break;
									}
								case EST_SIP_PROCEEDING:
									{
									break;
									}
								case EST_SIP_COMPLETED_2xx:
									{
									break;
									}
								case EST_SIP_COMPLETED_2XX_ACK:
									{
									break;
									}
								case EST_SIP_COMPLETED:
									{
									break;
									}
								case EST_SIP_COMPLETED_ACK:
									{
									break;
									}
								case EST_SIP_TERMINATED:
									{
									break;
									}
								case EST_SIP_TERMINATED_OK:
									{
									break;
									}
								}
							}
						}

					infoPacketTransAux.Tipo.sprintf("%s", "REGISTER");
					}
				infoPacketTransAux.IPFrom.sprintf("%s", IPFrom);
				infoPacketTransAux.IPTo.sprintf("%s", IPTo);
				infoPacketTransAux.numTrans = transSel.at(j);
				infoPacketTransAux.state.sprintf("%s", state);
				infoPacketTransAux.tStart.sprintf("%s", tStart);
				infoPacketTransAux.tStop.sprintf("%s", tStop);
				infoPacketTransAux.userFrom.sprintf("%s", userFrom);
				infoPacketTransAux.userTo.sprintf("%s", userTo);

				infoPacketTransMain.append(infoPacketTransAux);
				}
			}
		}

	return (infoPacketTransMain);
	}

stream_RTP_t VoIPFixTransactions::setTransSelectedPlay (QList<packet_t> packetsList, int transSel)
	{
	stream_RTP_t streamRTP;
	int typeTrans;
	int seqOrg;
	int seqRec;
	bool firstOrg;
	bool firstRec;
	QList <int> packetsTrans;
	int packetsTransSize;
	transaction_t transactionsAux;
	packet_t packet;
	int k, j;
	sniff_ip *header_ip;
	int size_ip;
	u_char *payloadRTP;

	typeTrans = transGetTypeTrans(transSel);

	if ((typeTrans == TRANS_TYPE_INVITE) || (typeTrans == TRANS_TYPE_REGISTER))
		{
      packetsTrans = getListTransPackets(transSel);
		packetsTransSize = packetsTrans.size();

		//using quick sort to sort list of packages
		quickSortPackets(&packetsTrans, 0, packetsTransSize-1);

		transactionsAux = transactions.at(transSel);

		firstOrg = false;
		firstRec = false;
		streamRTP.originator.clear();
		streamRTP.receiver.clear();

		//ToDo - Should synchronize the flow
		for (k = 0; k < packetsTransSize; k++)
			{
			packet = packetsList.at(packetsTrans.at(k));
			if (packet.infoRTP != NULL)
				{	// RTP packet
				//Start of IP
				header_ip = (struct sniff_ip*)(packet.pkt_data + SIZE_ETHERNET);
				size_ip = IP_HL(header_ip)*4;
				payloadRTP = (u_char*)(packet.pkt_data + SIZE_ETHERNET + size_ip + 8 + 12);

				if (packet.infoRTP->ssrc == transactionsAux.ssrcSrc)
					{	// packet of the call originator
					if (firstOrg == false)
						{
						//ToDo -  160 if 20 ms packet size
						for (j = 0; j < 160; j++)
							{
							streamRTP.originator.append(payloadRTP[j]);
							}
						streamRTP.codecOriginator = packet.infoRTP->pt;
						firstOrg = true;
						seqOrg = packet.infoRTP->seq;
						}
					else
						{
						if (packet.infoRTP->seq == seqOrg + 1)
							{
							//ToDo -  160 if 20 ms packet size
							for (j = 0; j < 160; j++)
								{
								streamRTP.originator.append(payloadRTP[j]);
								}
							}
						else
							{
							if (packet.infoRTP->pt == G711_PCMA)
								{
								for (; seqOrg < packet.infoRTP->seq; seqOrg++)
									{
									//ToDo -  160 if 20 ms packet size
									for (j = 0; j < 160; j++)
										{
										streamRTP.originator.append(SILENCIO_PCMA);
										}
									}
								}
							else if (packet.infoRTP->pt == G711_PCMU)
								{
								for (; seqOrg < packet.infoRTP->seq; seqOrg++)
									{
									//ToDo -  160 if 20 ms packet size
									for (j = 0; j < 160; j++)
										{
										streamRTP.originator.append(SILENCIO_PCMU);
										}
									}
								}
							}
						seqOrg = packet.infoRTP->seq;
						}
					}
				else if (packet.infoRTP->ssrc == transactionsAux.ssrcDst)
					{	// packet of the call receiver
					if (firstRec == false)
						{
						//ToDo -  160 if 20 ms packet size
						for (j = 0; j < 160; j++)
							{
							streamRTP.receiver.append(payloadRTP[j]);
							}
						streamRTP.codecReceiver = packet.infoRTP->pt;
						firstRec = true;
						seqRec = packet.infoRTP->seq;
						}
					else
						{
						if (packet.infoRTP->seq == seqRec + 1)
							{
							//ToDo -  160 if 20 ms packet size
							for (j = 0; j < 160; j++)
								{
								streamRTP.receiver.append(payloadRTP[j]);
								}
							}
						else
							{
							if (packet.infoRTP->pt == G711_PCMA)
								{
								for (; seqRec < packet.infoRTP->seq; seqRec++)
									{
									//ToDo -  160 if 20 ms packet size
									for (j = 0; j < 160; j++)
										{
										streamRTP.receiver.append(SILENCIO_PCMA);
										}
									}
								}
							else if (packet.infoRTP->pt == G711_PCMU)
								{
								for (; seqRec < packet.infoRTP->seq; seqRec++)
									{
									//ToDo -  160 if 20 ms packet size
									for (j = 0; j < 160; j++)
										{
										streamRTP.receiver.append(SILENCIO_PCMU);
										}
									}
								}
							}
						seqRec = packet.infoRTP->seq;
						}
					}
				}
			}
		}
	return (streamRTP);
	}


void VoIPFixTransactions::clearInfoPacket(infoReportTrans_t *info)
	{
	info->numTrans = 0;
	info->tStart = "-";
	info->tStop = "-";
	info->Tipo = "-";
	info->IPFrom = "-";
	info->userFrom = "-";
	info->IPTo = "-";
	info->userTo = "-";
	info->state = "-";
	info->duration = "-";
	info->Codec = "-";
	info->meanJitterOrg = "-";
	info->maxJitterOrg = "-";
	info->packetLostPercOrg = "-";
	info->sequenceErrorOrg = "-";
	info->meanJitterRec = "-";
	info->maxJitterRec = "-";
	info->packetLostPercRec = "-";
	info->sequenceErrorRec = "-";
	info->erroRTP = ERROR_RTP_NOTHING;
	info->erroRTPText.clear();;
	info->erroSIP = ERROR_SIP_NOTHING;
	info->erroSIPText.clear();
	}

void VoIPFixTransactions::clearTransState (transState_t *trans)
	{
	trans->state = EST_SIP_IDDLE;
	trans->status = TRANS_STATUS_NONE;
	trans->ip.ipdw = 0;
	trans->codecs.clear();
	trans->registerTime = 0;
	trans->CSeq = 0;
	}

void VoIPFixTransactions::initSeqSourceRTP (sourceRTP_t *s, unsigned short seq, unsigned int ts, timeval ar)
	{
	double arrival;

	arrival = ar.tv_sec + (double)ar.tv_usec/1000000;

	s->base_seq = seq;
	s->max_seq = seq;
	s->bad_seq = RTP_SEQ_MOD + 1; /* so seq == bad_seq is false */
	s->cycles = 0;
	s->received = 0;
	s->received_prior = 0;
	s->expected_prior = 0;
	s->jitter = 0;
	s->meanJitter = 0;
	s->maxJitter = 0;
	s->transit = arrival;
	s->timeStamp = ts;
	s->sequenceError = 0;
	s->absence = false;
	}

int VoIPFixTransactions::updateSeqRTP(sourceRTP_t *s, unsigned short seq, timeval ar, unsigned int ts)
	{
	unsigned short udelta = seq - s->max_seq;

	if (s->probation)
		{
		if (seq == s->max_seq + 1)
			{
			s->probation--;
			s->max_seq = seq;
			if (s->probation == 0)
				{
				initSeqSourceRTP(s, seq, ts, ar);
				s->received++;
				return 1;
				}
			}
		else
			{
			s->probation = MIN_SEQUENTIAL - 1;
			s->max_seq = seq;
			}

		return 0;
		}
	else if (udelta < MAX_DROPOUT)
		{
		if (seq < s->max_seq)
			{
			s->cycles += RTP_SEQ_MOD;
			}
		s->max_seq = seq;
		}
	else if (udelta <= RTP_SEQ_MOD - MAX_MISORDER)
		{
		if (seq == s->bad_seq)
			{
			initSeqSourceRTP(s, seq, ts, ar);
			}
		else
			{
			s->bad_seq = (seq + 1) & (RTP_SEQ_MOD-1);			
			return 0;
			}
		}
	else
		{
		}

	s->received++;

	return 1;
	}

void VoIPFixTransactions::jitterCalcPackets (sourceRTP_t *s, unsigned short seq, timeval ar, unsigned int ts)
	{
	double d;
	double arrival;
	double jitter;

	arrival = ar.tv_sec + (double)ar.tv_usec/1000000;

	//D(0,1) = (R1 - R0) - (S1 - S0)
	d = (arrival - s->transit) - (((double)ts * 0.000125) - ((double)s->timeStamp * 0.000125));

	//J(1) = J(0) + (|D(0,1)| - J(0))/16
	if (d < 0)
		d = -d;

	jitter = s->jitter + ((d - s->jitter)/16.);
	s->jitter = jitter;

	s->transit = arrival;
	s->timeStamp = ts;

	s->meanJitter += s->jitter;
	if (s->jitter > s->maxJitter)
		s->maxJitter = s->jitter;

	if (seq != s->base_seq + 1)
		{
		s->sequenceError++;
		if ((seq - s->base_seq) > RTP_MAX_INTERVALO)
			{
			s->absence = true;
			}
		}
	s->base_seq = seq;
	s->received++;
	}

void VoIPFixTransactions::quickSortInfoPackets(QList <infoPacketTrans_t> *infoP, int p, int r)
	{
	int q;
	if (p < r)
		{
		q = partitionInfoPackets(infoP, p, r);
		quickSortInfoPackets(infoP, p, q - 1);
		quickSortInfoPackets(infoP, q + 1, r);
		}
	}

int VoIPFixTransactions::partitionInfoPackets(QList <infoPacketTrans_t> *infoP, int p, int r)
	{
	int i, j;
	infoPacketTrans_t infoAux;

	i = p;

	for (j = p + 1; j <= r; ++j)
		{
		if (infoP->at(j).numPacket < infoP->at(p).numPacket)
			{
			++i;
			infoAux.numPacket = infoP->at(j).numPacket;
			infoAux.numTrans = infoP->at(j).numTrans;
			infoP->replace(j, infoP->at(i));
			infoP->replace(i, infoAux);
			}
		}

	infoAux.numPacket = infoP->at(p).numPacket;
	infoAux.numTrans = infoP->at(p).numTrans;
	infoP->replace(p, infoP->at(i));
	infoP->replace(i, infoAux);

	return (i);
	}

void VoIPFixTransactions::quickSortPackets(QList <int> *lstPackets, int p, int r)
	{
	int q;
	if (p < r)
		{
		q = partitionPackets(lstPackets, p, r);
		quickSortPackets(lstPackets, p, q - 1);
		quickSortPackets(lstPackets, q + 1, r);
		}
	}

int VoIPFixTransactions::partitionPackets(QList <int> *lstPackets, int p, int r)
	{
	int i, j;
	int packetAux;

	i = p;

	for (j = p + 1; j <= r; ++j)
		{
		if (lstPackets->at(j) < lstPackets->at(p))
			{
			++i;
			packetAux = lstPackets->at(j);
			lstPackets->replace(j, lstPackets->at(i));
			lstPackets->replace(i, packetAux);
			}
		}

	packetAux = lstPackets->at(p);
	lstPackets->replace(p, lstPackets->at(i));
	lstPackets->replace(i, packetAux);

	return (i);
	}

int VoIPFixTransactions::transGetSizeAll(void)
   {
   return transactions.size();
   }

QList<int> VoIPFixTransactions::getListTransPackets(int numTrans)
	{
	transaction_t transactionsAux;
	if ((numTrans >=0) && (numTrans < transactions.size()))
		{
		transactionsAux = transactions.at(numTrans);
		return (transactionsAux.posPackets);
		}
	transactionsAux = transactions.at(0);
	return (transactionsAux.posPackets);
	}

QList <transList_t> VoIPFixTransactions::getListTrans(void)
	{
	return (transLista);
	}

void VoIPFixTransactions::bubbleSortPackets(int pos)
	{
	transaction_t transactionsAux;
	bool swap;
	swap = true;
	transactionsAux = transactions.at(pos);

	for(int j = 0; swap; j++)
		{
		swap = false;
		for(int k = transactionsAux.posPackets.size()-1; k > j; k--)
			{
			if(transactionsAux.posPackets.at(k) < transactionsAux.posPackets.at(k-1))
				{
				int temp;
				temp = transactionsAux.posPackets.at(k);
				transactionsAux.posPackets.operator [](k) = transactionsAux.posPackets.at(k-1);
				transactionsAux.posPackets.operator [](k-1) = temp;
				swap = true;
				}
			}
		}
	transactions.replace(pos, transactionsAux);
	}

void VoIPFixTransactions::analysisFinished(QList<packet_t> lista)
	{
	transaction_t transactionsAux;
	packet_t firstPacket;
	packet_t lastPacket;
	char tStart[30];
	char tStop[30];
	char IPFrom[24];
	char * userFrom = NULL;
	char IPTo[24];
	char * userTo = NULL;
	char state[50];
	transList_t transListaAux;

	time_t *local_tv_sec;
	struct tm *ltime;
	char timestr[16];
	int i;
	int listaSize;

	listaSize = transactions.size();

	for (i = 0; i < listaSize; i++)
		{
		transactionsAux = transactions.at(i);
		if (transactionsAux.numPacketReq < 0)
			{
			firstPacket = lista.at(transactionsAux.posPackets.at(0));
			}
		else
			{
			firstPacket = lista.at(transactionsAux.numPacketReq);
			}
		userFrom = firstPacket.sip_message->from->url->username;
		userTo = firstPacket.sip_message->to->url->username;

		sprintf(IPFrom, "%i.%i.%i.%i",   firstPacket.infoUDP->ip_src.ip[0], firstPacket.infoUDP->ip_src.ip[1],
													firstPacket.infoUDP->ip_src.ip[2], firstPacket.infoUDP->ip_src.ip[3]);

		sprintf(IPTo, "%i.%i.%i.%i",     firstPacket.infoUDP->ip_dst.ip[0], firstPacket.infoUDP->ip_dst.ip[1],
													firstPacket.infoUDP->ip_dst.ip[2], firstPacket.infoUDP->ip_dst.ip[3]);

		local_tv_sec = &firstPacket.header->ts.tv_sec;
		ltime = localtime (local_tv_sec);
		strftime( timestr, sizeof timestr, "%H:%M:%S", ltime);
		sprintf(tStart, "%s.%.6ld", timestr, firstPacket.header->ts.tv_usec);

		lastPacket = lista.at(transactionsAux.posPackets.at(transactionsAux.posPackets.size()-1));
		local_tv_sec = &lastPacket.header->ts.tv_sec;
		ltime = localtime (local_tv_sec);
		strftime( timestr, sizeof timestr, "%H:%M:%S", ltime);
		sprintf(tStop, "%s.%.6ld", timestr, lastPacket.header->ts.tv_usec);

      intStatusCodeToStr(transactionsAux.statusCode, &state[0]);

		transListaAux.numTrans = i;
		transListaAux.tStart = firstPacket.header->ts;
		transListaAux.tStop = lastPacket.header->ts;
		transListaAux.sipMethod = firstPacket.sip_message->sip_method;
		transListaAux.ipFrom.ipdw = firstPacket.infoUDP->ip_src.ipdw;
		transListaAux.ipTo.ipdw = firstPacket.infoUDP->ip_dst.ipdw;
		transListaAux.userFrom = userFrom;
		transListaAux.userTo = userTo;
		transListaAux.state = transactionsAux.statusCode;
		transLista.append(transListaAux);

		emit findTransactionComplete(i, &tStart[0], tStop, firstPacket.sip_message->sip_method, &IPFrom[0], userFrom, &IPTo[0], userTo, state);
		}
   emit (analysisFinishedSignal(numSIP, numRTP));
	}

int VoIPFixTransactions::rxPacket (packet_t packet)
   {
   transaction_t transactionsAux;
	packet_t firstPacket;
	packet_t lastPacket;
   char tStart[30];
   char tStop[30];
   char IPFrom[24];
   char * userFrom = NULL;
   char IPTo[24];
   char * userTo = NULL;
   char state[50];
   transList_t transListaAux;

   time_t *local_tv_sec;
   struct tm *ltime;
   char timestr[16];

	listaPacotesAux.append(packet);
	packetAnalyser(packet);
   if (transCapNew != -1)
      {
      transactionsAux = transactions.at(transCapNew);
      if (transactionsAux.numPacketReq < 0)
         {
			firstPacket = listaPacotesAux.at(transactionsAux.posPackets.at(0));
         }
      else
         {
			firstPacket = listaPacotesAux.at(transactionsAux.numPacketReq);
         }

      lastPacket = listaPacotesAux.at(transactionsAux.posPackets.at(transactionsAux.posPackets.size()-1));

      if ((firstPacket.sip_message != NULL) && (lastPacket.sip_message != NULL))
         {
         userFrom = firstPacket.sip_message->from->url->username;
         userTo = firstPacket.sip_message->to->url->username;

         sprintf(IPFrom, "%i.%i.%i.%i",   firstPacket.infoUDP->ip_src.ip[0], firstPacket.infoUDP->ip_src.ip[1],
                                          firstPacket.infoUDP->ip_src.ip[2], firstPacket.infoUDP->ip_src.ip[3]);

         sprintf(IPTo, "%i.%i.%i.%i",     firstPacket.infoUDP->ip_dst.ip[0], firstPacket.infoUDP->ip_dst.ip[1],
                                          firstPacket.infoUDP->ip_dst.ip[2], firstPacket.infoUDP->ip_dst.ip[3]);

         local_tv_sec = &firstPacket.header->ts.tv_sec;
         ltime = localtime (local_tv_sec);
         strftime( timestr, sizeof timestr, "%H:%M:%S", ltime);
         sprintf(tStart, "%s.%.6ld", timestr, firstPacket.header->ts.tv_usec);

         lastPacket = listaPacotesAux.at(transactionsAux.posPackets.at(transactionsAux.posPackets.size()-1));
         local_tv_sec = &lastPacket.header->ts.tv_sec;
         ltime = localtime (local_tv_sec);
         strftime( timestr, sizeof timestr, "%H:%M:%S", ltime);
         sprintf(tStop, "%s.%.6ld", timestr, lastPacket.header->ts.tv_usec);

         intStatusCodeToStr(transactionsAux.statusCode, &state[0]);

         transListaAux.numTrans = transCapNew;
         transListaAux.tStart = firstPacket.header->ts;
         transListaAux.tStop = lastPacket.header->ts;
         transListaAux.sipMethod = firstPacket.sip_message->sip_method;
         transListaAux.ipFrom.ipdw = firstPacket.infoUDP->ip_src.ipdw;
         transListaAux.ipTo.ipdw = firstPacket.infoUDP->ip_dst.ipdw;
         transListaAux.userFrom = userFrom;
         transListaAux.userTo = userTo;
         transListaAux.state = transactionsAux.statusCode;
         transLista.append(transListaAux);
         emit findTransaction(transCapNew, &tStart[0], tStop, firstPacket.sip_message->sip_method, &IPFrom[0], userFrom, &IPTo[0], userTo);
         transCapNew = -1;
         }
      }
   if (transCapUpdate != -1)
      {
      transactionsAux = transactions.at(transCapUpdate);
      intStatusCodeToStr(transactionsAux.statusCode, &state[0]);
      emit (updateTransaction (transCapUpdate, state));
      transCapUpdate = -1;
      }
   return 0;
   }

void VoIPFixTransactions::setParamFilter (transFilter_t tFilter)
	{
	int listSize, j;
	int transFilterSize;
	char tStart[30];
	char tStop[30];
	char IPFrom[24];
	char IPTo[24];
	char state[50];
   QString strAux;

	bool tipoOK;
	bool statusOK;

	int findUserFrom;
	int findUserTo;

	int findIPFrom;
	int findIPTo;

	QTime tStartTrans;
	QTime tZero;

	time_t *local_tv_sec;
	struct tm *ltime;
	char timestr[16];


	listSize = transLista.size();
	tZero.setHMS(0, 0, 0);
	transFilterSize = 0;
	for (j = 0; j < listSize; j++)
		{
		//--- Start: transaction type---
		tipoOK = false;
		if (!tFilter.All)
			{	//not all
			if (tFilter.Calls && (QString::compare(transLista.at(j).sipMethod, "INVITE", Qt::CaseInsensitive) == 0))
				{
				tipoOK = true;
				}
			else if (tFilter.Register && (QString::compare(transLista.at(j).sipMethod, "REGISTER", Qt::CaseInsensitive) == 0))
				{
				tipoOK = true;
				}
			}
		else
			{
			tipoOK = true;
			}

		if (!tipoOK)
			{
			continue;
			}
		//--- End: transaction type ---



		//--- Start: interval time of the transaction ---
		local_tv_sec = (time_t* )&(transLista.at(j).tStart.tv_sec);
		ltime = localtime (local_tv_sec);
		tStartTrans.setHMS(ltime->tm_hour, ltime->tm_min, ltime->tm_sec);

		if ((tFilter.tStart.operator !=(tZero)) && (tFilter.tStop.operator !=(tZero)))
			{
			if ((tStartTrans.operator <(tFilter.tStart)) || (tStartTrans.operator >(tFilter.tStop)))
				{
				continue;
				}
			}
		else if (tFilter.tStop.operator ==(tZero))
			{
			if (tStartTrans.operator <(tFilter.tStart))
				{
				continue;
				}
			}
		else if (tFilter.tStart.operator ==(tZero))
			{
			if (tStartTrans.operator >(tFilter.tStop))
				{
				continue;
				}
			}
		//--- End: interval time of the transaction ---



		//--- Start: IP address of source and destination---
		if (tFilter.ipFromAndIpTo)
			{	//have to match the IP address of the source and destination
			if (tFilter.ipFrom.ipdw)
				{	// to test From IP
				if (tFilter.ipFromEqual)
					{	//only if from user is equal
					if (tFilter.ipFrom.ipdw != transLista.at(j).ipFrom.ipdw)
						{	//not equal, so go to next
						continue;
						}
					}
				else
					{	//only if from IP is different
					if (tFilter.ipFrom.ipdw == transLista.at(j).ipFrom.ipdw)
						{	//no difference, so go to next
						continue;
						}
					}
				}
			if (tFilter.ipTo.ipdw)
				{	// to test To IP
				if (tFilter.ipToEqual)
					{	//only if To IP is different
					if (tFilter.ipTo.ipdw != transLista.at(j).ipTo.ipdw)
						{	//no equal, so go to next
						continue;
						}
					}
				else
					{	//only if To user is different
					if (tFilter.ipTo.ipdw == transLista.at(j).ipTo.ipdw)
						{	//no difference, so go to next
						continue;
						}
					}
				}
			}
		else
			{	//have to match source or destination IP
			findIPFrom = 0;
			if (tFilter.ipFrom.ipdw)
				{	// to test From user
				findIPFrom = 1;
				if (tFilter.ipFromEqual)
					{
					if (tFilter.ipFrom.ipdw == transLista.at(j).ipFrom.ipdw)
						{
						findIPFrom = 2;
						}
					}
				else
					{
					if (tFilter.ipFrom.ipdw != transLista.at(j).ipFrom.ipdw)
						{
						findIPFrom = 2;
						}
					}
				}

			findIPTo = 0;
			if (tFilter.ipTo.ipdw)
				{
				findIPTo = 1;
				if (tFilter.ipToEqual)
					{
					if (tFilter.ipTo.ipdw == transLista.at(j).ipTo.ipdw)
						{
						findIPTo = 2;
						}
					}
				else
					{
					if (tFilter.ipTo.ipdw != transLista.at(j).ipTo.ipdw)
						{
						findIPTo = 2;
						}
					}
				}
			if ((findIPFrom == 0) && (findIPTo == 1))
				{	//was to find To, but found not
				continue;
				}
			else if ((findIPFrom == 1) && (findIPTo == 0))
				{	//was to find From, but found not
				continue;
				}
			else if ((findIPFrom == 1) && (findIPTo == 1))
				{	//was to find From or To, but found none
				continue;
				}
			}
		//--- Start: IP address of source and destination--- ---


		//--- Start: source and destination User ---
		if (tFilter.userFromAndUserTo)
			{	//have to match source and destination user
			if (tFilter.isUserFrom)
				{	// need to test from user
				if (tFilter.userFromEqual)
					{	//only if from user is equal
					if (QString::compare(tFilter.userFrom, transLista.at(j).userFrom, Qt::CaseInsensitive) != 0)
						{	//not  equal, so go to next
						continue;
						}
					}
				else
					{	//only if from user is different
					if (QString::compare(tFilter.userFrom, transLista.at(j).userFrom, Qt::CaseInsensitive) == 0)
						{	//not different, so go to next
						continue;
						}
					}
				}
			if (tFilter.isUserTo)
				{	// need to test To User
				if (tFilter.usertoEqual)
					{	//only if To user is equal
					if (QString::compare(tFilter.userTo, transLista.at(j).userTo, Qt::CaseInsensitive) != 0)
						{	//not  equal, so go to next
						continue;
						}
					}
				else
					{	//only if To user is different
					if (QString::compare(tFilter.userTo, transLista.at(j).userTo, Qt::CaseInsensitive) == 0)
						{	//not  different, so go to next
						continue;
						}
					}
				}
			}
		else
			{	//have to match source or destination user
			findUserFrom = 0;
			if (tFilter.isUserFrom)
				{	// need to test From user
				findUserFrom = 1;
				if (tFilter.userFromEqual)
					{
					if (QString::compare(tFilter.userFrom, transLista.at(j).userFrom, Qt::CaseInsensitive) == 0)
						{
						findUserFrom = 2;
						}
					}
				else
					{
					if (QString::compare(tFilter.userFrom, transLista.at(j).userFrom, Qt::CaseInsensitive) != 0)
						{
						findUserFrom = 2;
						}
					}
				}

			findUserTo = 0;
			if (tFilter.isUserTo)
				{
				findUserTo = 1;
				if (tFilter.usertoEqual)
					{
					if (QString::compare(tFilter.userTo, transLista.at(j).userTo, Qt::CaseInsensitive) == 0)
						{
						findUserTo = 2;
						}
					}
				else
					{
					if (QString::compare(tFilter.userTo, transLista.at(j).userTo, Qt::CaseInsensitive) != 0)
						{
						findUserTo = 2;
						}
					}
				}
			if ((findUserFrom == 0) && (findUserTo == 1))
				{	//was to find To, but found not
				continue;
				}
			else if ((findUserFrom == 1) && (findUserTo == 0))
				{	//was to find From, but found not
				continue;
				}
			else if ((findUserFrom == 1) && (findUserTo == 1))
				{	//was to find From or To, but found none
				continue;
				}
			}
		//--- End: source and destination user ---



		//--- Start: transaction status ---
		statusOK = false;
		if (!tFilter.statusAll)
			{
			if (tFilter.statusFinished && (transLista.at(j).state == TRANS_STATUS_BYE))
				{
				statusOK = true;
				}
			else if (tFilter.statusCompleted && ((transLista.at(j).state == 200) || (transLista.at(j).state == 202)))
				{
				statusOK = true;
				}
			else if (tFilter.statusBusy && (transLista.at(j).state == 486))
				{
				statusOK = true;
				}
			else if (tFilter.statusCanceled && (transLista.at(j).state == TRANS_STATUS_CANCEL))
				{
				statusOK = true;
				}
			else if (tFilter.statusRefused && (transLista.at(j).state == 403))
				{
				statusOK = true;
				}
			else if (tFilter.statusNotAuthorized && ((transLista.at(j).state == 401 || transLista.at(j).state == 407)))
				{
				statusOK = true;
				}
			else if (tFilter.statusUnsupportedMedia && (transLista.at(j).state == 415))
				{
				statusOK = true;
				}
			}
		else
			{
			statusOK = true;
			}

		if (!statusOK)
			{
			continue;
			}
		//--- End: transaction status ---



		sprintf(IPFrom, "%i.%i.%i.%i",   transLista.at(j).ipFrom.ip[0], transLista.at(j).ipFrom.ip[1],
													transLista.at(j).ipFrom.ip[2], transLista.at(j).ipFrom.ip[3]);

		sprintf(IPTo, "%i.%i.%i.%i",     transLista.at(j).ipTo.ip[0], transLista.at(j).ipTo.ip[1],
													transLista.at(j).ipTo.ip[2], transLista.at(j).ipTo.ip[3]);

		local_tv_sec = (time_t* )&(transLista.at(j).tStart.tv_sec);
		ltime = localtime (local_tv_sec);
		strftime( timestr, sizeof timestr, "%H:%M:%S", ltime);
		sprintf(tStart, "%s.%.6ld", timestr, transLista.at(j).tStart.tv_usec);

		local_tv_sec = (time_t* )&transLista.at(j).tStop.tv_sec;
		ltime = localtime (local_tv_sec);
		strftime( timestr, sizeof timestr, "%H:%M:%S", ltime);
		sprintf(tStop, "%s.%.6ld", timestr, transLista.at(j).tStop.tv_usec);

      intStatusCodeToStr(transLista.at(j).state, &state[0]);

		emit findTransactionComplete(transLista.at(j).numTrans, &tStart[0], &tStop[0], transLista.at(j).sipMethod.toLatin1().data(), &IPFrom[0], transLista.at(j).userFrom.toLatin1().data(), &IPTo[0], transLista.at(j).userTo.toLatin1().data(), state);
		transFilterSize++;
		}
	strAux = QString(tr("Nmero de transaes: %1").arg(transFilterSize));
   emit (statusMessage(strAux));
	}

void packetAnalyser(packet_t packet)
	{
	char * call_id = NULL;
	char * media_type;
	char * c_addr;
	char * m_port;
	int posFind;
	int typeTrans;
	int typeReq;
	int statusCode;
	int j;

	typeReq = TRANS_TYPE_NONE;
	if (packet.sip_message != NULL)
		{
		if (osip_call_id_to_str(packet.sip_message, &call_id) == 0)
			{
			mutexLock.lock();
			posFind = transFind(call_id, 0, 0);

			if (posFind == -1)
				{	//transaction does not exist
				if ((posFind = transAdd(call_id, packet.numPacote, NULL)) != -1)
					{	//transaction added sucessful
					mutexLock.unlock();
					if (packet.sip_message->sip_method != NULL)
						{	//request message
						typeReq = strToIntTypeTrans(packet.sip_message->sip_method);
						if ((typeReq == TRANS_TYPE_INVITE) || (typeReq == TRANS_TYPE_REGISTER) ||
							 (typeReq == TRANS_TYPE_OPTIONS) || (typeReq == TRANS_TYPE_NOTIFY))
							{	//request that initiates the transaction
							transSetTypeTrans(posFind, typeReq, NULL, packet.numPacote);
							}
						else if (typeReq == TRANS_TYPE_CANCEL)
							{	//request that changes the transaction status
							transSetStatusCodeDif(posFind, TRANS_STATUS_CANCEL);
							}
						else if (typeReq == TRANS_TYPE_BYE)
							{	//request that changes the transaction status
							transSetStatusCodeDif(posFind, TRANS_STATUS_BYE);
							}
						//ignore else
						}
					else
						{	//answer message
						transSetStatusCodeDif(posFind, packet.sip_message->status_code);
						}
					}
				else
					{
					mutexLock.unlock();
					}
				}
			else
				{	//transaction already exist
				mutexLock.unlock();
				transAddPacket(posFind, packet.numPacote);
				if (packet.sip_message->sip_method != NULL)
					{	//request message
					typeReq = strToIntTypeTrans(packet.sip_message->sip_method);
					typeTrans = transGetTypeTrans(posFind);
					if ((typeTrans == TRANS_TYPE_INVITE) || (typeTrans == TRANS_TYPE_REGISTER) ||
						(typeTrans == TRANS_TYPE_OPTIONS) || (typeTrans == TRANS_TYPE_NOTIFY))
						{	//request that changes the transaction status
						if (typeReq == TRANS_TYPE_BYE)
							{	//request that changes the transaction status
							transSetStatusCodeDif(posFind, TRANS_STATUS_BYE);
							}
						else if (typeReq == TRANS_TYPE_CANCEL)
							{	//request that changes the transaction status
							transSetStatusCodeDif(posFind, TRANS_STATUS_CANCEL);
							}
						//ignore else
						}
					else
						{	//transaction does not have type yet
						if ((typeReq == TRANS_TYPE_INVITE) || (typeReq == TRANS_TYPE_REGISTER) ||
							(typeReq == TRANS_TYPE_OPTIONS) || (typeReq == TRANS_TYPE_NOTIFY))
							{	//request that initiates the transaction
							transSetTypeTrans(posFind, typeReq, NULL, packet.numPacote);
							}
						else if (typeReq == TRANS_TYPE_CANCEL)
							{	//request that changes the transaction status
							transSetStatusCodeDif(posFind, TRANS_STATUS_CANCEL);
							}
						else if (typeReq == TRANS_TYPE_BYE)
							{	//request that changes the transaction status
							transSetStatusCodeDif(posFind, TRANS_STATUS_BYE);
							}
						//ignore else
						}
					}
				else if ((packet.sip_message->sip_method == NULL) && (packet.sip_message->status_code >= 0))
					{	//answer message
					statusCode = transGetStatusCode(posFind);
					if ((statusCode != TRANS_STATUS_CANCEL) && (statusCode != TRANS_STATUS_BYE))
						{	//maybe can be changed the status of the transaction
						if (packet.sip_message->status_code == 100)
							{	//Trying message
							if (statusCode <= 100)
								{	//can change (or set) the transaction status
								transSetStatusCodeDif(posFind, 100);
								}
							//ignore else. Status of the transaction already has more than 100.
							}
						else if (statusCode != 200)
							{
							transSetStatusCodeDif(posFind, packet.sip_message->status_code);
							}
						}
					//ignore else. Current status should not be changed for any other
					}
				//ignore else
				}
			if ((posFind != -1) && (packet.sdp_message != NULL))
				{	// a SIP message with SDP
				for (j = 0; j < 10; j ++)
					{
					media_type = sdp_message_m_media_get(packet.sdp_message, j);
					if (media_type == NULL)
						break;
					if (strcmp (media_type, "audio") == 0)
						{	// audio media
						c_addr = sdp_message_c_addr_get(packet.sdp_message, -1, 0);
						m_port = sdp_message_m_port_get(packet.sdp_message, j);

						if (typeReq == TRANS_TYPE_NONE)
							{	//it isn't request message
							if ((packet.sip_message->status_code == 200) || (packet.sip_message->status_code == 183))
								{
								transAddMedia(posFind, c_addr, m_port, 1);
								}
							}
						else
							{	// a request message
							transAddMedia(posFind, c_addr, m_port, 0);
							}
						}
					}
				}
			free(call_id);
			}
		}
	else
		{	//it isn't a packet with SIP message.
		if (packet.infoRTP != NULL)
			{	//but is a RTP packet
			transAddMediaPkt(packet.numPacote, packet.infoUDP, packet.infoRTP);
			}

		}
	}

int transAdd(char * call_id, int posPacket, char * strType)
	{
	QWriteLocker locker(&lock);

	int res = -1;
	transaction_t sAux;

	if ((call_id != NULL) && (call_id[0]))
		{
		sAux.call_id = (char*)malloc(strlen(call_id) + 1);
		sAux.lock = new QReadWriteLock;
		strcpy (sAux.call_id, call_id);
		sAux.statusCode = TRANS_STATUS_NONE;
		sAux.ipMediaSrc.ipdw = 0;
		sAux.ipMediaDst.ipdw = 0;
		sAux.portMediaSrc = 0;
		sAux.portMediaDst = 0;
		sAux.mediaDstOK = false;
		sAux.mediaSrcOK = false;
		sAux.ssrcDst = 0;
		sAux.ssrcSrc = 0;
		sAux.numPacketReq = -1;
		sAux.posPackets.clear();
		sAux.tipoTrans = strToIntTypeTrans(strType);
		sAux.posPackets.append(posPacket);
		transactions.append(sAux);
		res = transactions.size() - 1;
      numSIP++;
		}
	return res;
	}

int transFind (char * call_id, int posIni, int posEnd)
	{
	QWriteLocker locker(&lock);
	int res = -1;
	int listSize;
	int i;

	listSize = transactions.size();
	for (i = 0; i < listSize; i++)
		{
		if (strcmp(transactions.at(i).call_id, call_id) == 0)
			{
			res = i;
			break;
			}
		}

	return res;
	}

void transAddMedia (int pos, char * ipMedia, char * portMedia, int Which)
	{
	int ip1, ip2, ip3, ip4;
	transaction_t * transactionsAux;
	transactionsAux = &transactions.operator [](pos);

	QWriteLocker locker(transactionsAux->lock);

	sscanf(ipMedia, "%d.%d.%d.%d", &ip1, &ip2, &ip3, &ip4);
	if (Which == 0)
		{	//source, of request message
		transactionsAux->portMediaSrc = atoi(portMedia);
		transactionsAux->ipMediaSrc.ip[0] = ip1;
		transactionsAux->ipMediaSrc.ip[1] = ip2;
		transactionsAux->ipMediaSrc.ip[2] = ip3;
		transactionsAux->ipMediaSrc.ip[3] = ip4;
		transactionsAux->mediaSrcOK = true;
		}
	else if (Which == 1)
		{	//destination, of answer message
		transactionsAux->portMediaDst = atoi(portMedia);
		transactionsAux->ipMediaDst.ip[0] = ip1;
		transactionsAux->ipMediaDst.ip[1] = ip2;
		transactionsAux->ipMediaDst.ip[2] = ip3;
		transactionsAux->ipMediaDst.ip[3] = ip4;
		transactionsAux->mediaDstOK = true;
		}
	}

void transAddMediaPkt (int posPacket, infoUDP_t * infoUDP, infoRTP_t * infoRTP)
	{
	int j, listaSize;
	transaction_t *transactionsAux;

	QWriteLocker locker(&lock);
	listaSize = transactions.size();
	for (j = listaSize - 1; j >= 0; j--)
		{
		transactionsAux = &transactions.operator [](j);
		if ((transactionsAux->tipoTrans == TRANS_TYPE_INVITE) &&
			(transactionsAux->statusCode != TRANS_STATUS_BYE) &&
			(transactionsAux->statusCode != TRANS_STATUS_CANCEL) &&
			(posPacket > transactionsAux->numPacketReq))
			{
			if ((infoUDP->ip_dst.ipdw == transactionsAux->ipMediaDst.ipdw) && (infoUDP->udp_dport == transactionsAux->portMediaDst))
				{	//Originator flow, because the packet has as destination the address offered in 200 OK, ie, who received the call.
				transactionsAux->posPackets.append(posPacket);
				transactionsAux->ssrcSrc = infoRTP->ssrc;
            numRTP++;
				break;
				}
			else if ((infoUDP->ip_src.ipdw == transactionsAux->ipMediaSrc.ipdw) && (infoUDP->udp_sport == transactionsAux->portMediaSrc))
				{	//Originator flow, because the packet has source address offered in INVITE by the call originator.
				transactionsAux->posPackets.append(posPacket);
				transactionsAux->ssrcSrc = infoRTP->ssrc;
            numRTP++;
				break;
				}
			else if ((infoUDP->ip_dst.ipdw == transactionsAux->ipMediaSrc.ipdw) && (infoUDP->udp_dport == transactionsAux->portMediaSrc))
				{	//Receiver flow, because the packet has as destination the address offered by the INVITE originator
				transactionsAux->posPackets.append(posPacket);
				transactionsAux->ssrcDst = infoRTP->ssrc;
            numRTP++;
            break;
				}
			else if ((infoUDP->ip_src.ipdw == transactionsAux->ipMediaDst.ipdw) && (infoUDP->udp_sport == transactionsAux->portMediaDst))
				{	//Receiver flow, because the packet has source address offered in 200 OK by the receiver call
				transactionsAux->posPackets.append(posPacket);
				transactionsAux->ssrcDst = infoRTP->ssrc;
            numRTP++;
            break;
				}
			}		
		}
	}

int transGetStatusCode(int pos)
	{
	int res = -1;
	transaction_t transactionsAux;

	res = transactions.at(pos).statusCode;
	return (res);
	}

int transSetStatusCodeDif (int pos, int statusCode)
	{
	transaction_t * transactionsAux;
	transactionsAux = &transactions.operator [](pos);
	QWriteLocker locker(transactionsAux->lock);
	transactionsAux->statusCode = statusCode;
   transCapUpdate = pos;
	return 0;
	}

int transAddPacket(int numTransaction, int packetPos)
	{
	QWriteLocker locker(&lock);
	transaction_t *transactionsAux;
	transactionsAux = &transactions.operator [](numTransaction);
	transactionsAux->posPackets.append(packetPos);
   numSIP++;
	return (0);
	}

int transSetTypeTrans (int numTransaction, int intType, char *strTipo, int numPacket)
	{
	transaction_t *transactionsAux;
	transactionsAux = &transactions.operator [](numTransaction);
	QWriteLocker locker(transactionsAux->lock);
	if (strTipo != NULL)
		{
      transactionsAux->tipoTrans = strToIntTypeTrans(strTipo);
		}
	else
		{
		transactionsAux->tipoTrans = intType;
		}
	transactionsAux->numPacketReq = numPacket;
   transCapNew = numTransaction;
	return 0;
	}

int transGetTypeTrans (int numTransaction)
	{
	transaction_t transactionsAux;
	transactionsAux = transactions.at(numTransaction);
	return (transactionsAux.tipoTrans);
	}

int strToIntTypeTrans (char * strType)
	{
	if ((strType == NULL) || (!strType[0]))
		{
		return (TRANS_TYPE_NONE);
		}
	else if (strcmp ("REGISTER", strType) == 0)
		{
		return (TRANS_TYPE_REGISTER);
		}
	else if (strcmp ("INVITE", strType) == 0)
		{
		return (TRANS_TYPE_INVITE);
		}
	else if (strcmp ("ACK", strType) == 0)
		{
		return (TRANS_TYPE_ACK);
		}
	else if (strcmp ("CANCEL", strType) == 0)
		{
		return (TRANS_TYPE_CANCEL);
		}
	else if (strcmp ("BYE", strType) == 0)
		{
		return (TRANS_TYPE_BYE);
		}
	else if (strcmp ("OPTIONS", strType) == 0)
		{
		return (TRANS_TYPE_OPTIONS);
		}
	else if (strcmp ("INFO", strType) == 0)
		{
		return (TRANS_TYPE_INFO);
		}
	else if (strcmp ("REFER", strType) == 0)
		{
		return (TRANS_TYPE_REFER);
		}
	else if (strcmp ("NOTIFY", strType) == 0)
		{
		return (TRANS_TYPE_NOTIFY);
		}
	else
		{
		return (TRANS_TYPE_NONE);
		}
	}

void intStatusCodeToStr(int intStatusCode, char *strStatusCode)
	{
	switch (intStatusCode)
		{
		case 100:
			{
			strcpy (strStatusCode, QObject::tr("Tentando").toLatin1().data());
			break;
			}
		case 180:
			{
			strcpy (strStatusCode, QObject::tr("Chamando").toLatin1().data());
			break;
			}
		case 181:
		case 182:
		case 183:
			{
			strcpy (strStatusCode, QObject::tr("Em progresso").toLatin1().data());
			break;
			}
		case 200:
		case 202:
			{
			strcpy (strStatusCode, QObject::tr("Completada").toLatin1().data());
			break;
			}
		case 401:
			{
			strcpy (strStatusCode, QObject::tr("No autorizada").toLatin1().data());
			break;
			}
		case 403:
			{
			strcpy (strStatusCode, QObject::tr("Negada").toLatin1().data());
			break;
			}
		case 404:
			{
			strcpy (strStatusCode, QObject::tr("No encontrada").toLatin1().data());
			break;
			}
		case 405:
			{
			strcpy (strStatusCode, QObject::tr("Mtodo no permitido").toLatin1().data());
			break;
			}
		case 407:
			{
			strcpy (strStatusCode, QObject::tr("Autenticao requerida").toLatin1().data());
			break;
			}
		case 415:
			{
			strcpy (strStatusCode, QObject::tr("Mdia no suportada").toLatin1().data());
			break;
			}
		case 423:
			{
			strcpy (strStatusCode, QObject::tr("Intervalo muito curto").toLatin1().data());
			break;
			}
		case 480:
			{
			strcpy (strStatusCode, QObject::tr("Temporariamente indisponvel").toLatin1().data());
			break;
			}
		case 486:
			{
			strcpy (strStatusCode, QObject::tr("Ocupada").toLatin1().data());
			break;
			}
		case TRANS_STATUS_BYE:
			{
			strcpy (strStatusCode, QObject::tr("Terminada").toLatin1().data());
			break;
			}
		case TRANS_STATUS_CANCEL:
			{
			strcpy (strStatusCode, QObject::tr("Cancelada").toLatin1().data());
			break;
			}
		default:
			{
			strcpy (strStatusCode, QObject::tr("Desconhecida").toLatin1().data());
			}
		}
	}
