#ifndef VOIPFIXWINPCAP_H
#define VOIPFIXWINPCAP_H

#ifndef HAVE_REMOTE
#define HAVE_REMOTE
#endif

#include <QtGui>

#ifdef Q_OS_UNIX
#include <netinet/in.h>
#endif

//#ifdef Q_OS_WIN
#include <pcap.h>
#include <stdlib.h>
//#endif

class QStringList;

class VoIPFixWinpCap : public QThread
	{
	Q_OBJECT
	public:
		VoIPFixWinpCap();
		~VoIPFixWinpCap();
      int startWinpCap();
		QStringList * getDeviceList();
		int openDevice (int deviceNumber, int inPromiscuousMode, char * filter);
		void closeDevice (void);
		int openFile (char * fileName, char * filter);
		int openFileSequencial(QStringList fileNames, char * filter);
		void closeFile (void);
      int saveFile (char * fileName);      
      int packetDumpFile (const struct pcap_pkthdr *header, const u_char *pkt_data);
      int closeDumpFile (void);

	public slots:
      void run (void);

	signals:
		void winPacket(pcap_pkthdr *header, const u_char *pkt_data);
      void winEOF(void);
		void nFile(void);

	private:
		QStringList * deviceList;
		pcap_if_t * alldevs;
		pcap_t * adhandle;
      pcap_dumper_t *dumpfile;
      bool deviceOpened;
      bool fileOpened;
		bool openSequential;
      bool closeStopDevice;
		QStringList fileNames;
		int contFileSequential;
		char * filterSet;

	private slots:
		void nextFileSequential(void);
	};

#endif // VOIPFIXWINPCAP_H
