#include <QtGui>
#include "windowcapture.h"

WindowCapture::WindowCapture()
	{
	setupUi(this);

	setFixedSize(480, 100);
	setWindowTitle(tr("Configurar Captura"));
	setAttribute(Qt::WA_DeleteOnClose);

	connect(buttonBox, SIGNAL(accepted()), this, SLOT(okButton()));
	connect(buttonBox, SIGNAL(rejected()), this, SLOT(cancelButton()));
   canceling = false;
	}

void WindowCapture::addDevice(QStringList *deviceList)
	{
	cmbInterface->clear();
	cmbInterface->addItems(*deviceList);
	}

void WindowCapture::okButton(void)
	{
	emit configCapture(cmbInterface->currentIndex(), edtFilter->text().toLatin1().data());
	}

void WindowCapture::cancelButton(void)
	{
   if (!canceling)
      {
      canceling = true;
      emit configCancel(false);
      }
	}

void WindowCapture::closeEvent(QCloseEvent *event)
   {
   if (!canceling)
      {
      canceling = true;
      emit configCancel(true);
      }
   }

