#ifndef WINDOWESTATISTICAS_H
#define WINDOWESTATISTICAS_H

#include <QtGui>
#include <pcap.h>
#include <osipparser2/osip_message.h>
#include <osipparser2/sdp_message.h>
#include <osipparser2/osip_parser.h>
#include <defines.h>
#include <structs.h>

#include <ui_WindowEstatisticas.h>

#include <bargraph.h>

void quickSortEstUser(QList <estUser_t> *eUser, int p, int r);
int partitionEstUser(QList <estUser_t> *eUser, int p, int r);

void quickSortEstIP(QList <estIP_t> *eUser, int p, int r);
int partitionEstIP(QList <estIP_t> *eUser, int p, int r);

class GeralTab : public QWidget
	{
	Q_OBJECT

	public:
		GeralTab(QList <transList_t> tLista, QWidget *parent = 0);

	private:
		QGraphicsScene *sceneGeral;
		QGraphicsView *viewGeral;
		barGraph *bar;
	};

class InfoChamadasTab : public QWidget
	{
	Q_OBJECT

	public:
		InfoChamadasTab(QList <transList_t> tLista, QWidget *parent = 0);

	private:
		QGraphicsScene *sceneGeral;
		QGraphicsView *viewGeral;
		barGraph *bar;
	};

class UserFromChamadasTab : public QWidget
	{
	Q_OBJECT

	public:
		UserFromChamadasTab(QList <transList_t> tLista, QWidget *parent = 0);

	private:
		QGraphicsScene *sceneGeral;
		QGraphicsView *viewGeral;
		barGraph *bar;
	};

class UserToChamadasTab : public QWidget
	{
	Q_OBJECT

	public:
		UserToChamadasTab(QList <transList_t> tLista, QWidget *parent = 0);

	private:
		QGraphicsScene *sceneGeral;
		QGraphicsView *viewGeral;
		barGraph *bar;
	};

class IPFromChamadasTab : public QWidget
	{
	Q_OBJECT

	public:
		IPFromChamadasTab(QList <transList_t> tLista, QWidget *parent = 0);

	private:
		QGraphicsScene *sceneGeral;
		QGraphicsView *viewGeral;
		barGraph *bar;
	};

class IPToChamadasTab : public QWidget
	{
	Q_OBJECT

	public:
		IPToChamadasTab(QList <transList_t> tLista, QWidget *parent = 0);

	private:
		QGraphicsScene *sceneGeral;
		QGraphicsView *viewGeral;
		barGraph *bar;
	};

class InfoRegistroTab : public QWidget
	{
	Q_OBJECT

	public:
		InfoRegistroTab(QList <transList_t> tLista, QWidget *parent = 0);

	private:
		QGraphicsScene *sceneGeral;
		QGraphicsView *viewGeral;
		barGraph *bar;
	};

class UserFromRegistroTab : public QWidget
	{
	Q_OBJECT

	public:
		UserFromRegistroTab(QList <transList_t> tLista, QWidget *parent = 0);

	private:
		QGraphicsScene *sceneGeral;
		QGraphicsView *viewGeral;
		barGraph *bar;
	};

class IPFromRegistroTab : public QWidget
	{
	Q_OBJECT

	public:
		IPFromRegistroTab(QList <transList_t> tLista, QWidget *parent = 0);

	private:
		QGraphicsScene *sceneGeral;
		QGraphicsView *viewGeral;
		barGraph *bar;
	};

class IPToRegistroTab : public QWidget
	{
	Q_OBJECT

	public:
		IPToRegistroTab(QList <transList_t> tLista, QWidget *parent = 0);

	private:
		QGraphicsScene *sceneGeral;
		QGraphicsView *viewGeral;
		barGraph *bar;
	};

class WindowStatistics : public QMainWindow, public Ui::WindowEstatisticas
	{
	Q_OBJECT

	public:
		WindowStatistics();
		void closeEvent(QCloseEvent *event);
		void setInfoTrans (QList <transList_t> tLista);

	signals:
      void closingStatistics(bool closing);

	private:
		QList <transList_t> transLista;
		QTabWidget *tabWidget;
	};

#endif // WINDOWESTATISTICAS_H
