#include "windowfilter.h"

WindowFilter::WindowFilter()
	{
	setupUi(this);

	setFixedSize(540, 342);
	setWindowTitle(tr("Filtro de Transaes"));
	setAttribute(Qt::WA_DeleteOnClose);

	connect (buttonBox, SIGNAL(accepted()), this, SLOT(buttonOk()));
	connect (buttonBox, SIGNAL(rejected()), this, SLOT(close()));
	connect (chkTipoTodas, SIGNAL(toggled(bool)), chkTipoChamada, SLOT(setDisabled(bool)));
	connect (chkTipoTodas, SIGNAL(toggled(bool)), chkTipoRegistro, SLOT(setDisabled(bool)));
	chkTipoTodas->setChecked(true);

	connect (chkStatusTodos, SIGNAL(toggled(bool)), chkStatusCancelado, SLOT(setDisabled(bool)));
	connect (chkStatusTodos, SIGNAL(toggled(bool)), chkStatusCompletado, SLOT(setDisabled(bool)));
	connect (chkStatusTodos, SIGNAL(toggled(bool)), chkStatusMidiaNaoSuportada, SLOT(setDisabled(bool)));
	connect (chkStatusTodos, SIGNAL(toggled(bool)), chkStatusNaoAutorizado, SLOT(setDisabled(bool)));
	connect (chkStatusTodos, SIGNAL(toggled(bool)), chkStatusNegado, SLOT(setDisabled(bool)));
	connect (chkStatusTodos, SIGNAL(toggled(bool)), chkStatusOcupado, SLOT(setDisabled(bool)));
	connect (chkStatusTodos, SIGNAL(toggled(bool)), chkStatusTerminado, SLOT(setDisabled(bool)));
	chkStatusTodos->setChecked(true);
	}

void WindowFilter::closeEvent(QCloseEvent *event)
	{
	emit closingFilter(true);
	}

void WindowFilter::buttonOk (void)
	{
	transFilter_t tFilter;

	//Start -- Transaction type
	tFilter.Calls = false;
	tFilter.Register = false;
	tFilter.All = false;

	if (chkTipoTodas->isChecked())
		{
		tFilter.All = true;
		}
	else
		{
		if (chkTipoChamada->isChecked())
			{
			tFilter.Calls = true;
			}
		if (chkTipoRegistro->isChecked())
			{
			tFilter.Register = true;
			}
		}
	//End -- Transaction type


	//Start -- Time interval
	tFilter.tStart = timeEditHoraDe->time();
	tFilter.tStop = timeEditHoraAte->time();
	//End -- Time interval


	//Start -- Source address
	tFilter.ipFrom.ipdw = 0;
	sscanf(edtIPFrom->text().toLatin1().data(), "%i.%i.%i.%i", &tFilter.ipFrom.ip[0], &tFilter.ipFrom.ip[1], &tFilter.ipFrom.ip[2], &tFilter.ipFrom.ip[3]);
	tFilter.isIpFrom = true;
	tFilter.ipFromEqual = rdbIpOrigemIgual->isChecked();
	//End -- Source address


	//Start -- Destination address
	tFilter.ipTo.ipdw = 0;
	sscanf(edtIPTo->text().toLatin1().data(), "%i.%i.%i.%i", &tFilter.ipTo.ip[0], &tFilter.ipTo.ip[1], &tFilter.ipTo.ip[2], &tFilter.ipTo.ip[3]);
	tFilter.isIpTo = true;
	tFilter.ipToEqual = rdbUserOrigemIgual->isChecked();
	tFilter.ipFromAndIpTo = rdbIpE->isChecked();
	//End -- Destination address


	//Start -- Source user
   if (edtUserFrom->text() != "")
		{
		tFilter.isUserFrom = true;
		tFilter.userFrom = edtUserFrom->text();
      tFilter.userFromEqual = rdbUserOrigemIgual->isChecked();
		}
   else
      {
      tFilter.isUserFrom = false;
      }
	//End -- Source user

	//Start -- Destination user
   if (edtUserTo->text() != "")
		{
		tFilter.isUserTo = true;
		tFilter.userTo = edtUserTo->text();
      tFilter.usertoEqual = rdbUserDestinoIgual->isChecked();
		}
   else
      {
      tFilter.isUserTo = false;
      }
   tFilter.userFromAndUserTo = rdbUserE->isChecked();
	//End -- Destination user

	//Start -- Finalization status
   tFilter.statusAll = chkStatusTodos->isChecked();
   tFilter.statusFinished = chkStatusTerminado->isChecked();
   tFilter.statusCompleted = chkStatusCompletado->isChecked();
   tFilter.statusBusy = chkStatusOcupado->isChecked();
   tFilter.statusCanceled = chkStatusCancelado->isChecked();
   tFilter.statusRefused = chkStatusNegado->isChecked();
   tFilter.statusNotAuthorized = chkStatusNaoAutorizado->isChecked();
   tFilter.statusUnsupportedMedia = chkStatusMidiaNaoSuportada->isChecked();
	//End -- Finalization status

	emit (paramFilter(tFilter));
	emit closingFilter(true);
	}

