#include "windowgraph.h"
#include "coluna.h"
#include "textip.h"
#include "texthour.h"
#include "arrow.h"

WindowGraph::WindowGraph()
	{   
	setWindowTitle(tr("Grfico de Transaes"));
	setAttribute(Qt::WA_DeleteOnClose);
	}

void WindowGraph::closeEvent(QCloseEvent *event)
	{
	emit closingGraph(true);
	}

QRect WindowGraph::setInfoGraph(QList <infoPacketTrans_t> infoPacket)
	{
	int i, listaSize, numTrans, numIP;
   int maxW, maxH;
	int posColumn;
	int posArrowStart, posArrowEnd, posArrowY, dirArrow;
	IPADDRESS_t ipAux;
	QString strIpAux;
	QList <int> ipList;
	QList <int> transList;
	QList <int> posIPColumn;
	QList <QColor> transColor;

	time_t local_tv_sec;
	struct tm *ltime;
	char timestr[16];
	char tStart[30];

	ipList.clear();
	transList.clear();
	transColor.clear();
	listaSize = infoPacket.size();
	srand(time(NULL));

	for (i = 0; i < listaSize; i++)
		{
		ipAux = infoPacket.at(i).srcIP;
		if (!ipList.contains(ipAux.ipdw))
			{
			ipList.append(ipAux.ipdw);
			}
		ipAux = infoPacket.at(i).dstIP;
		if (!ipList.contains(ipAux.ipdw))
			{
			ipList.append(ipAux.ipdw);
			}
		numTrans = infoPacket.at(i).numTrans;
		if (!transList.contains(numTrans))
			{
			transList.append(numTrans);
			transColor.append(QColor(rand() % 150, rand() % 150, rand() % 150, 200));
			}
		}
	numIP = ipList.size();

	//max size of the chart
   maxW = 120 + (ipList.size() - 1) * 200;
	maxH = 20 + (listaSize * 20);

   if (maxW < 500)
		{
		maxW = 500;
      }

   if (maxH < 400)
      {
		maxH = 400;
		}

   sceneGraph = new QGraphicsScene();
   sceneGraph->setSceneRect((QRectF(0, 0, maxW, maxH)));
   viewGraph = new QGraphicsView();
   viewGraph->setScene(sceneGraph);
   viewGraph->setRenderHints(QPainter::Antialiasing | QPainter::TextAntialiasing);
   viewGraph->setMinimumSize(500, 400);
   viewGraph->setMaximumSize(maxW, maxH);
   viewGraph->centerOn(0, 0);
   viewGraph->setFrameShape(QFrame::NoFrame);

   sceneHour = new QGraphicsScene(0, 0, 90, maxH);
   viewHour = new QGraphicsView();
   viewHour->setScene(sceneHour);
   viewHour->setRenderHints(QPainter::Antialiasing | QPainter::TextAntialiasing);
   viewHour->setMinimumSize(90, 400);
   viewHour->setMaximumSize(90, maxH);
   viewHour->centerOn(0, 0);
   viewHour->setVerticalScrollBarPolicy(Qt::ScrollBarAlwaysOff);
   viewHour->setHorizontalScrollBarPolicy(Qt::ScrollBarAlwaysOff);
   viewHour->setFrameShape(QFrame::NoFrame);
   viewHour->setBackgroundBrush(QBrush(Qt::lightGray));

   sceneIP = new QGraphicsScene();
   sceneIP->setSceneRect(QRectF(0, 0, maxW, 30));
   viewIP = new QGraphicsView();
   viewIP->setScene(sceneIP);
   viewIP->setRenderHints(QPainter::Antialiasing | QPainter::TextAntialiasing);
   viewIP->setMinimumSize(500, 30);
   viewIP->setMaximumSize(maxW, 30);
   viewIP->centerOn(0, 0);
   viewIP->setVerticalScrollBarPolicy(Qt::ScrollBarAlwaysOff);
   viewIP->setHorizontalScrollBarPolicy(Qt::ScrollBarAlwaysOff);
   viewIP->setFrameShape(QFrame::NoFrame);
   viewIP->setBackgroundBrush(QBrush(Qt::lightGray));

   sceneHourText = new QGraphicsScene(0, 0, 90, 30);
   viewHourText = new QGraphicsView();
   viewHourText->setScene(sceneHourText);
   viewHourText->setRenderHints(QPainter::Antialiasing | QPainter::TextAntialiasing);
   viewHourText->setMinimumSize(90, 30);
   viewHourText->setMaximumSize(90, 30);
   viewHourText->centerOn(0, 0);
   viewHourText->setVerticalScrollBarPolicy(Qt::ScrollBarAlwaysOff);
   viewHourText->setHorizontalScrollBarPolicy(Qt::ScrollBarAlwaysOff);
   viewHourText->setFrameShape(QFrame::NoFrame);
   viewHourText->setBackgroundBrush(QBrush(Qt::lightGray));

   viewGraph->setVerticalScrollBar(viewHour->verticalScrollBar());
   viewGraph->setHorizontalScrollBar(viewIP->horizontalScrollBar());

   QGridLayout *layout = new QGridLayout();
   layout->setVerticalSpacing(0);
   layout->setHorizontalSpacing(0);
   layout->addWidget(viewHourText, 0, 0);
   layout->addWidget(viewHour, 1, 0);
   layout->addWidget(viewIP, 0, 1);
   layout->addWidget(viewGraph, 1, 1);

   layout->setColumnStretch(1, 20);
   layout->setRowStretch(1, 20);

   QWidget *widget = new QWidget;
   widget->setLayout(layout);
   setCentralWidget(widget);

	widget->setMaximumSize(maxW + 110, maxH + 50);
	widget->setMinimumSize(590, 430);

	Coluna *coluna;
	TextIP *textIP;
	TextHour *textHour;
	Arrow *arrow;

	posColumn = 60;
	posIPColumn.clear();
	for (i = 0; i < numIP; i++)
		{
		coluna = new Coluna();
		coluna->drawColumn(posColumn, 0, maxH);
		sceneGraph->addItem(coluna);

		textIP = new TextIP();
		ipAux.ipdw = ipList.at(i);
		strIpAux.clear();
		strIpAux.sprintf("%i.%i.%i.%i", ipAux.ip[0], ipAux.ip[1], ipAux.ip[2], ipAux.ip[3]);
		textIP->drawIP(posColumn, strIpAux);
		sceneIP->addItem(textIP);
		posIPColumn.append(posColumn);
		posColumn += 200;
		}

	posArrowY = 10;
	for (i = 0; i < listaSize; i++)
		{
		arrow = new Arrow();
		textHour = new TextHour();
		posArrowStart = posIPColumn.at(ipList.indexOf(infoPacket.at(i).srcIP.ipdw, 0));
		posArrowEnd = posIPColumn.at(ipList.indexOf(infoPacket.at(i).dstIP.ipdw, 0));


		local_tv_sec = infoPacket.at(i).time.tv_sec;
		ltime = localtime (&local_tv_sec);
		strftime( timestr, sizeof timestr, "%H:%M:%S", ltime);
		sprintf(tStart, "%s.%.6ld", timestr, infoPacket.at(i).time.tv_usec);
		tStart[12] = 0;

		textHour->drawHour(posArrowY, tStart);
		sceneHour->addItem(textHour);

		if (posArrowStart < posArrowEnd)
			{
			dirArrow = 1;
			}
		else
			{
			dirArrow = 0;
			}

		arrow->drawArrow(posArrowY, posArrowStart, posArrowEnd, dirArrow, transColor.at(transList.indexOf(infoPacket.at(i).numTrans)), infoPacket.at(i).info, infoPacket.at(i).srcPort, infoPacket.at(i).dstPort, infoPacket.at(i).numPacket);
		connect (arrow, SIGNAL(packetClicked(int)), this, SIGNAL(packetClicked(int)));
		sceneGraph->addItem(arrow);
		posArrowY += 20;
		}
	return (QRect(20, 20, 612, 475));
   }
