#ifndef WINDOWPACKETS_H
#define WINDOWPACKETS_H

#include <QtGui>
#include <pcap.h>
#include <osipparser2/osip_message.h>
#include <osipparser2/sdp_message.h>
#include <osipparser2/osip_parser.h>
#include <defines.h>
#include <structs.h>

class windowPackets : public QMainWindow
	{
	Q_OBJECT

	public:
		windowPackets();
		void closeEvent(QCloseEvent *event);
		void setInfoPackets(QList <infoPacketTrans_t> infoPacket, QList<packet_t> listaP);
		void clearPackets(void);
		void setPacketClicked (int numPacket);

	public slots:
		void tClicked(QModelIndex modelIndex);

	signals:
		void closingPackest(bool closing);

	protected:
	  void contextMenuEvent(QContextMenuEvent *event);

	private:
		int numPackets;
		QTreeView *packetsView;
		QSortFilterProxyModel *packetsModel;
		QStandardItemModel *model;
		QStandardItemModel *createMailModel(QObject *parent);
		void creatActions(void);
		void setSourceModel(QAbstractItemModel *model);

		QTreeWidget *infoView;
		QTreeWidgetItem * addParent(QTreeWidgetItem *pai, QString texto);

		QList<packet_t> packetsList;
		QList <infoPacketTrans_t> infoPacketAux;
	};

#endif // WINDOWPACKETS_H
