#ifndef WINDOWPLAY_H
#define WINDOWPLAY_H

#include <QtGui>
#include <pcap.h>
#include <osipparser2/osip_message.h>
#include <osipparser2/sdp_message.h>
#include <osipparser2/osip_parser.h>
#include <defines.h>
#include <structs.h>

#include <Phonon/MediaObject>
#include <Phonon/Path>
#include <Phonon/AudioOutput>
#include <Phonon/Global>
#include <Phonon/SeekSlider>
#include <Phonon/VolumeSlider>

class WindowPlay : public QMainWindow
	{
	Q_OBJECT

	public:
		WindowPlay();
      ~WindowPlay();

		void closeEvent(QCloseEvent *event);
		void setInfoPlay(stream_RTP_t streamRTP);

	signals:
		void closingPlay(bool closing);

	private slots:
		void rewind();
		void playPause();
		void updateTime();
		void stateChanged(Phonon::State newstate, Phonon::State oldstate);
		void bufferStatus(int percent);

	private:
		QIcon playIcon;
		QIcon pauseIcon;
		Phonon::MediaObject m_MediaObject;
		Phonon::AudioOutput m_AudioOutput;
		Phonon::Path m_audioOutputPath;
		QPushButton *playButton;
		QPushButton *rewindButton;
		Phonon::SeekSlider *slider;
		Phonon::VolumeSlider *volume;
		QLabel *timeLabel;
		QLabel *progressLabel;
	};

#endif // WINDOWPLAY_H
