#ifndef WINDOWREPORT_H
#define WINDOWREPORT_H

#include <QtGui>
#include <pcap.h>
#include <osipparser2/osip_message.h>
#include <osipparser2/sdp_message.h>
#include <osipparser2/osip_parser.h>
#include <defines.h>
#include <structs.h>

class WindowReport : public QMainWindow
	{
	Q_OBJECT

	public:
		WindowReport();
		void closeEvent(QCloseEvent *event);
		void setInfoPackets(QList <infoReportTrans_t> infoPacket, QList<packet_t> listaP);

	public slots:
		void tClicked(QModelIndex modelIndex);

	signals:
		void closingReport(bool closing);

	private:
		QList <infoReportTrans_t> infoReportAux;
		int numTrans;
		QTreeView *transView;
		QTextEdit *infoView;
		QSortFilterProxyModel *transModel;
		QStandardItemModel *model;
		QStandardItemModel *createMailModel(QObject *parent);
		void creatActions(void);
		void setSourceModel(QAbstractItemModel *model);
	};

#endif // WINDOWREPORT_H
