#ifndef WINDOWTRANSACTIONS_H
#define WINDOWTRANSACTIONS_H

#include <QtGui>
#include <ui_windowTransactions.h>

class WindowTransactions : public QWidget, public Ui::WindowTransactions
	{
	Q_OBJECT

	public:
		WindowTransactions();
      ~WindowTransactions();
      void closeEvent(QCloseEvent *event);
      void clearTransactions(void);

	protected:
	  void contextMenuEvent(QContextMenuEvent *event);

	public slots:
		void addPacket(int numTrans, char * tStart, char * tStop, char * Tipo, char * IPFrom, char * userFrom, char * IPTo, char * userTo);
		void addPacketComplete(int numTrans, char * tStart, char * tStop, char * Tipo, char * IPFrom, char * userFrom, char * IPTo, char * userTo, char * State);
		void rxUpdateTransaction (int numTransaction, char * newState);
		void tClicked(QModelIndex modelIndex);
		void graphShow(void);
		void pacoteShow(void);
		void reportShow(void);
		void playExibe(void);

   signals:
      void closingTrans(bool closing);
		void transClicked (int numTrans);
		void transSelected (QList<int> transSel);
      void transSelectedLastPacket (QList<int> transSel);
		void transSelectedReport (QList<int> transSel);
		void transSelectedPlay (int transSel);
		void transFilter (void);

	private:
		QSortFilterProxyModel *packetsModel;
		QStandardItemModel *model;
		int numTransactions;
		QAction *graphAct;
		QAction *packetAct;
		QAction *reportAct;
		QAction *playAct;
		QAction *filterAct;

		QStandardItemModel *createMailModel(QObject *parent);
		void creatActions(void);
		void setSourceModel(QAbstractItemModel *model);

	};

#endif // WINDOWTRANSACTIONS_H
